
--
-- Table structure for table `admin`
--

DROP TABLE IF EXISTS `admin`;
CREATE TABLE `admin` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `username` text NOT NULL,
  `admin_name` text NOT NULL,
  `admin_email` text NOT NULL,
  `password` text NOT NULL,
  `superuser` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `answers`
--

DROP TABLE IF EXISTS `answers`;
CREATE TABLE `answers` (
  `answer_id` int(11) unsigned NOT NULL default '0',
  `questionnaire_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`answer_id`),
  KEY `questionnaire_id` (`questionnaire_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `folders_questionnaires`
--

DROP TABLE IF EXISTS `folders_questionnaires`;
CREATE TABLE `folders_questionnaires` (
  `id` int(11) NOT NULL auto_increment,
  `name` text NOT NULL,
  `parent_folder` int(11) NOT NULL default '0',
  `owner` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `folders_users`
--

DROP TABLE IF EXISTS `folders_users`;
CREATE TABLE `folders_users` (
  `id` int(11) NOT NULL auto_increment,
  `name` text NOT NULL,
  `parent_folder` int(11) NOT NULL default '0',
  `owner` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `in_category`
--

DROP TABLE IF EXISTS `in_category`;
CREATE TABLE `in_category` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `category_id` int(11) NOT NULL default '0',
  `question_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `new_email`
--

DROP TABLE IF EXISTS `new_email`;
CREATE TABLE `new_email` (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `email` text NOT NULL,
  `seed` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `question_alternatives`
--

DROP TABLE IF EXISTS `question_alternatives`;
CREATE TABLE `question_alternatives` (
  `id` int(11) NOT NULL auto_increment,
  `question_id` int(11) NOT NULL default '0',
  `alternative` text NOT NULL,
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `question_categories`
--

DROP TABLE IF EXISTS `question_categories`;
CREATE TABLE `question_categories` (
  `id` int(11) NOT NULL auto_increment,
  `questionnaire_id` int(11) NOT NULL default '0',
  `name` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `questionnaires`
--

DROP TABLE IF EXISTS `questionnaires`;
CREATE TABLE `questionnaires` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `master_question` int(10) unsigned default '0',
  `published` int(11) NOT NULL default '0',
  `deadline` int(10) unsigned NOT NULL default '0',
  `email_text` text NOT NULL,
  `folder_id` int(11) NOT NULL default '0',
  `owner` int(11) NOT NULL default '0',
  `report_published` tinyint(1) NOT NULL default '0',
  `result_comment_visible` text NOT NULL,
  `result_comment_invisible` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `questionnaires_data`
--

DROP TABLE IF EXISTS `questionnaires_data`;
CREATE TABLE `questionnaires_data` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `answer_id` int(11) NOT NULL default '0',
  `question_id` int(11) unsigned NOT NULL default '0',
  `response` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `answer_id` (`answer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `questionnaires_users`
--

DROP TABLE IF EXISTS `questionnaires_users`;
CREATE TABLE `questionnaires_users` (
  `questionnaire_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `response_time` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`questionnaire_id`,`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `questions`
--

DROP TABLE IF EXISTS `questions`;
CREATE TABLE `questions` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `questionnaire_id` int(11) unsigned NOT NULL default '0',
  `name` text NOT NULL,
  `negate` tinyint(1) NOT NULL default '0',
  `sort_order` int(10) unsigned NOT NULL default '0',
  `questiontype` text NOT NULL,
  `number_of_rows` int(11) NOT NULL default '3',
  `several` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `questionary_id` (`questionnaire_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `site_properties`
--

DROP TABLE IF EXISTS `site_properties`;
CREATE TABLE `site_properties` (
  `id` int(11) NOT NULL auto_increment,
  `site_title` text NOT NULL,
  `site_desc` text NOT NULL,
  `question_row_color1` varchar(7) NOT NULL default '#E2EFFC',
  `question_row_color2` varchar(7) NOT NULL default '#FFFFFF',
  `email_text` text NOT NULL,
  `site_manager` text NOT NULL,
  `site_manager_email` text NOT NULL,
  `site_smtp` text NOT NULL,
  `site_send_publish_mail` tinyint(1) NOT NULL default '0',
  `site_org` text NOT NULL,
  `site_admin_site` varchar(255) NOT NULL default 'admin/',
  `site_user_site` varchar(255) NOT NULL default '../',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` text NOT NULL,
  `email` text NOT NULL,
  `password` text NOT NULL,
  `folder_id` int(11) NOT NULL default '0',
  `owner` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
