<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: action_manage_questionnaire_users.inc.php,v 1.11 2006/06/07 12:57:38 medea1 Exp $
*/

$actionerror = 0;

if(!isset($_SESSION['active_questionnaire']))
{
	print_back('manage_questionnaires');
}
elseif(isset($_REQUEST['new_user']))
{
	include_once("inc/action_new_user.inc.php");
}
elseif(isset($_REQUEST['new_group']))
{
	include_once("inc/action_new_group.inc.php");
}
elseif(isset($_REQUEST['delete']))
{
	include_once("inc/manage_questionnaire_users.inc.php");
}
elseif(isset($_REQUEST['move']))
{
	if(isset($_POST['list']))
	{
		$access = 1;
		
		if(!$_SESSION['superuser'])
		{
			foreach($_POST['list'] AS $id)
			{
				if(is_numeric(substr($id, 6)) && strtolower(substr($id, 0, 6)) == "folder")
				{
					if(!access_to_folder($_SESSION['admin_id'], substr($id, 6), $mysql_handler, 1))
						$access = 0;
				}
			}
		}
		
		if(in_array("folder0", $_POST['list']))
				$access = 0;

		if($access)
		{
			unset($_SESSION['move_user_data']);

			if(is_array($_POST['list']))
			{
				$_SESSION['move_user_data']['files'] = array();
				$_SESSION['move_user_data']['folders'] = array();
			
				foreach($_POST['list'] AS $id)
				{
					if(!(strpos($id, "file") === FALSE))
					{
						if(is_numeric(substr($id, 4)))
							$_SESSION['move_user_data']['files'][] = substr($id, 4);
					}
					elseif(!(strpos($id, "folder") === FALSE))
					{
						if(is_numeric(substr($id, 6)))
							$_SESSION['move_user_data']['folders'][] = substr($id, 6);
					}
				}
			}

			print_back("manage_users_order");
		}
		else
		{
			$status[] = array('type' => 'error', 'text' => 'You are not allowed to move groups.');
			include_once("inc/manage_questionnaire_users.inc.php");
		}
	}
	else
	{
		$status[] = array('type' => 'error', 'text' => 'You did not select any groups or users.');
		$actionerror = 1;
		include_once("inc/manage_questionnaire_users.inc.php");
	}
}
elseif(isset($_POST['modify']))
{
	unset($_SESSION['modify_users']);
	if(is_array($_POST['list']))
	{
		$folder = 0;
		if(isset($_POST['list']))
		{
			if(is_array($_POST['list']) && !in_array("folder0", $_POST['list']))
			{
				$_SESSION['modify_users']['folder'] = array();
				$_SESSION['modify_users']['file'] = array();
	
				if(is_array($_POST['list']))
				{
					foreach($_POST['list'] AS $id)
					{
						if(!(strpos($id, "file") === FALSE))
						{
							if(is_numeric(substr($id, 4)))
								$_SESSION['modify_users']['file'][] = substr($id, 4);
						}
						elseif(!(strpos($id, "folder") === FALSE))
						{
							if(is_numeric(substr($id, 6)))
								$_SESSION['modify_users']['folder'][] = substr($id, 6);
							$folder = 1;
						}
					}
				}
	
				//access
				if(!$_SESSION['superuser'] && $folder)
				{
					$status[] = array('type' => 'error', 'text' => 'You do not have access to rename groups!');
					$actionerror = 1;
					include_once('inc/manage_questionnaire_users.inc.php');
				}
				else
				{
					print_back('change_user');
				}
			}
			else
			{
				$status[] = array('type' => 'error', 'text' => 'You can\'t rename the root group.');
				$actionerror = 1;
				include_once("inc/manage_questionnaire_users.inc.php");
			}
		}
		else
		{
			$actionerror = 1;
			$status[] = array('type' => 'error', 'text' => 'You have to select one or more groups/users to rename');
			include 'inc/manage_questionnaire_users.inc.php';
		}
	}
	else
	{
		$actionerror = 1;
		$status[] = array('type' => 'error', 'text' => 'You did not select any groups or users.');
		include 'inc/manage_questionnaire_users.inc.php';
	}
}
elseif(isset($_REQUEST['cancel']))
{
	include_once("inc/manage_questionnaire.inc.php");
}
else
{
	unset($_SESSION['data_confirm']);
	include_once("inc/manage_questionnaire_users.inc.php");
}
?>