<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: action_manage_questionnaires.inc.php,v 1.21 2006/06/07 09:50:51 medea1 Exp $
*/

$actionerror = 0;
$action_not_empty = 0;

if(isset($_POST['delete']))
{
	
	if(is_array($_POST['list']) && !in_array("folder0", $_POST['list']))
	{
		$notgood = false;
		if(is_array($_POST['list']))
		{
			$files = array();
			$folders = array();
		
			foreach($_POST['list'] AS $id)
			{
				if(!(strpos($id, "file") === FALSE))
				{
					if(is_numeric(substr($id, 4)))
						$files[] = substr($id, 4);
				}
				elseif(!(strpos($id, "folder") === FALSE))
				{
					if(is_numeric(substr($id, 6)) && substr($id, 6) != 0)
						$folders[] = substr($id, 6);
				}
			}
		
			foreach($files AS $id)
			{
				if(!access_to_file($_SESSION['admin_id'], $id, $mysql_handler))
					$notgood = true;
			}
		
			foreach($folders AS $id)
			{
				if(!access_to_folder($_SESSION['admin_id'], $id, $mysql_handler))
					$notgood = true;
	
				$sql = "SELECT * FROM questionnaires WHERE folder_id = $id";
				$result = my_query($sql, $mysql_handler);
				$data_files = mysql_fetch_assoc($result);
		
				$sql = "SELECT * FROM folders_questionnaires WHERE parent_folder = $id";
				$result = my_query($sql, $mysql_handler);
				$data_folders = mysql_fetch_assoc($result);
				
				if((!empty($data_files) || !empty($data_folders)) && !$action_not_empty)
				{
					$status[] = array('type' => 'error', 'text' => 'You can only delete empty folders.');
					$action_not_empty = 1;
				}
			}
		}
	
		if($notgood)
		{
			$status[] = array('type' => 'error', 'text' => 'You do not have access to the selected folders and questionnaires!');
			$actionerror = 1;
			include_once("inc/manage_questionnaires.inc.php");
		}
		elseif(isset($_POST['list']) && !$action_not_empty && (count($folders) > 0 || count($files) > 0))
			include_once("inc/confirm.inc.php");
		else
			include_once("inc/manage_questionnaires.inc.php");
	}
	else
	{
		if(is_array($_POST['list']) && in_array(0, $_POST['list']))
		{
			$status[] = array('type' => 'error', 'text' => 'You can\'t remove the root folder.');
			$actionerror = 1;
		}
		include_once("inc/manage_questionnaires.inc.php");
	}
}
elseif(isset($_POST['new_questionnaire']))
{
	unset($_SESSION['new_questionnaire_data']);
	include 'inc/new_questionnaire.inc.php';
}
elseif(isset($_POST['new_folder']))
{
	unset($_SESSION['new_folder_data']);
	include 'inc/new_folder.inc.php';
}
elseif(isset($_REQUEST['modify']))
	include 'inc/manage_questionnaire.inc.php';
elseif(isset($_REQUEST['move']))
{
	if(isset($_POST['list']))
	{
		if(is_array($_POST['list']) && !in_array("folder0", $_POST['list']))
		{
			unset($_SESSION['move_questionnaires_data']);
	
			$_SESSION['move_questionnaires_data']['files'] = array();
			$_SESSION['move_questionnaires_data']['folders'] = array();
		
			if(is_array($_POST['list']))
			{
				foreach($_POST['list'] AS $id)
				{
					if(!(strpos($id, "file") === FALSE))
					{
						if(is_numeric(substr($id, 4)))
							$_SESSION['move_questionnaires_data']['files'][] = substr($id, 4);
					}
					elseif(!(strpos($id, "folder") === FALSE))
					{
						if(is_numeric(substr($id, 6)))
							$_SESSION['move_questionnaires_data']['folders'][] = substr($id, 6);
					}
				}
			}
		
			$notgood = false;
	
			foreach($_SESSION['move_questionnaires_data']['files'] AS $id)
			{
				if(!access_to_file($_SESSION['admin_id'], $id, $mysql_handler))
					$notgood = true;
			}
		
			foreach($_SESSION['move_questionnaires_data']['folders'] AS $id)
			{
				if(!access_to_folder($_SESSION['admin_id'], $id, $mysql_handler))
					$notgood = true;
			}
	
			if($notgood)
			{
				$status[] = array('type' => 'error', 'text' => 'You do not have access to the selected folders and questionnaires!');
				$actionerror = 1;
				include_once('inc/manage_questionnaires.inc.php');
			}
			else
				print_back('manage_questionnaires_order');
		}
		else
		{
			$status[] = array('type' => 'error', 'text' => 'You can\'t move the root folder.');
			$actionerror = 1;
			include_once("inc/manage_questionnaires.inc.php");
		}
	}
	else
		include 'inc/manage_questionnaires.inc.php';

}
elseif(isset($_POST['rename']))
{
	unset($_SESSION['files_and_folders']);
	if(isset($_POST['list']))
	{
		if(is_array($_POST['list']) && !in_array("folder0", $_POST['list']))
		{
			$_SESSION['files_and_folders']['folder'] = array();
			$_SESSION['files_and_folders']['file'] = array();

			if(is_array($_POST['list']))
			{
				foreach($_POST['list'] AS $id)
				{
					if(!(strpos($id, "file") === FALSE))
					{
						if(is_numeric(substr($id, 4)))
							$_SESSION['files_and_folders']['file'][] = substr($id, 4);
					}
					elseif(!(strpos($id, "folder") === FALSE))
					{
						if(is_numeric(substr($id, 6)))
							$_SESSION['files_and_folders']['folder'][] = substr($id, 6);
					}
				}
			}

			$notgood = false;
	
			foreach($_SESSION['files_and_folders']['file'] AS $id)
			{
				if(!access_to_file($_SESSION['admin_id'], $id, $mysql_handler))
					$notgood = true;
			}
		
			foreach($_SESSION['files_and_folders']['folder'] AS $id)
			{
				if(!access_to_folder($_SESSION['admin_id'], $id, $mysql_handler))
					$notgood = true;
			}

			if($notgood)
			{
				$status[] = array('type' => 'error', 'text' => 'You do not have access to the selected folders and questionnaires!');
				$actionerror = 1;
				include_once('inc/manage_questionnaires.inc.php');
			}
			else
			{
				print_back('change_filetree');
			}
		}
		else
		{
			$status[] = array('type' => 'error', 'text' => 'You can\'t rename the root folder.');
			$actionerror = 1;
			include_once("inc/manage_questionnaires.inc.php");
		}
	}
	else
	{
		$actionerror = 1;
		$status[] = array('type' => 'error', 'text' => 'You have to select one or more folders/questionnaires to rename');
		include 'inc/manage_questionnaires.inc.php';
	}
}
else
	include 'inc/manage_questionnaires.inc.php';
?>