<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: append_question.inc.php,v 1.58 2006/06/07 14:13:50 medea2 Exp $
*/

// Print pathborder
$path[] = array('href' => return_href('manage_questionnaire'), 'name' => 'Manage: '.$_SESSION['active_questionnaire_name']);
$path[] = array('href' => return_href('manage_questions'), 'name' => 'Manage Questions');
$path[] = array('href' => '', 'name' => 'Append Question');

$path_back = return_href('manage_questions');

$pagetitle = 'Append Question';

$error = 0;
$ok = 0;

$questiontype = clean_string($_POST['questiontype']);

if($questiontype == 'textquestion' && isset($_POST['numb_rows']) && !(is_numeric($_POST['numb_rows']) && $_POST['numb_rows'] > 0 && $_POST['numb_rows'] % 1 == 0))
{
	$status[] = array('type' => 'error', 'text' => 'Number of rows has to be a number larger than 0.');
}

if(is_numeric($_SESSION['active_questionnaire']))
{
	if(!$_SESSION['owner_questionnaire'])
	{
		$status[] = array('type' => 'error', 'text' => 'Only the owner of a questionnaire can append questions to the questionnaire!');
		$error = 1;
		pageHeader($pagetitle, $path, $path_back, $status);
	}
	else
	{
		
		if(isset($_POST['rows']) && isset($_POST['up_alternative']))
		{
			foreach($_POST['rows'] AS $id)
			{
				$p = $_SESSION['alt_order'][$id];
				foreach($_SESSION['alt_order'] AS $key => $pos)
				{
					if($pos == $p - 1)
						$yay = $key;
				}
				if(isset($yay))
				{
					$_SESSION['alt_order'][$id]--;
					$_SESSION['alt_order'][$yay]++;
		
				}
		
			}
		}
		
		if(isset($_POST['rows']) && isset($_POST['down_alternative']))
		{
			foreach(array_reverse($_POST['rows']) AS $id)
			{
				$p = $_SESSION['alt_order'][$id];
				foreach($_SESSION['alt_order'] AS $key => $pos)
				{
					if($pos == $p + 1)
						$yay = $key;
				}
				if(isset($yay))
				{
					$_SESSION['alt_order'][$id]++;
					$_SESSION['alt_order'][$yay]--;
		
				}
		
			}
		}
		
		
		if(isset($_POST['rows']) && isset($_POST['delete_alternative']))
		{
			foreach($_POST['rows'] AS $id)
			{
				$p = $_SESSION['alt_order'][$id];
				foreach($_SESSION['alt_order'] AS $key => $order)
				{
					if($order > $p)
						$_SESSION['alt_order'][$key]--;
				}
		
				unset($_SESSION['alternatives'][$id]);
				unset($_SESSION['alt_order'][$id]);
			}
		}
		
		$altok = 0;
		
		if($_POST['questiontype'] != "multiple_choice")
			$altok = 1;
		elseif($_POST['questiontype'] == "multiple_choice" && count($_SESSION['alternatives']) > 0)
			$altok = 1;
		
		if(!empty($_POST['question']) && isset($_POST['submit']) && $altok == 1 && !error_to_report($status))
		{
			$value = clean_string($_POST['question']);
			if($_POST['negate'][$key]==true)
					$negate = 1;
				else
					$negate = 0;
		
			$questionnaire_id = $_SESSION['active_questionnaire'];
		
			$sql = "SELECT MAX(sort_order) FROM questions WHERE questionnaire_id = $questionnaire_id";
		
			$result = my_query($sql,$mysql_handler);
		
			$row = mysql_fetch_row($result);
			
			$questiontype = clean_string($_POST['questiontype']);
		
			$sort_order = $row[0] + 1;
			if($questiontype == 'textquestion')
			{	
				if(is_numeric($_POST['numb_rows']) && $_POST['numb_rows'] > 0)
					$numb_rows = $_POST['numb_rows'];
				else
					$numb_rows = 1;
				if(is_numeric($sort_order) && is_numeric($numb_rows))
				{
					$sql = "INSERT INTO questions ( name, questionnaire_id, negate, sort_order, questiontype, number_of_rows ) VALUES ('$value', {$_SESSION['active_questionnaire']}, $negate, $sort_order, '$questiontype', '$numb_rows')";
				}
			}
			elseif($questiontype == 'multiple_choice')
			{
				if(isset($_SESSION['several']))
					$several = 1;
				else
					$several = 0;

				if(is_numeric($sort_order))
				{
					$sql = "INSERT INTO questions ( name, questionnaire_id, negate, sort_order, questiontype, several) VALUES ('$value', {$_SESSION['active_questionnaire']}, $negate, $sort_order, '$questiontype', $several)";
				}
			}
			else
			{
				if(is_numeric($sort_order))
				{
					$sql = "INSERT INTO questions ( name, questionnaire_id, negate, sort_order, questiontype) VALUES ('$value', {$_SESSION['active_questionnaire']}, $negate, $sort_order, '$questiontype')";
				}
			}
		
			$commit = my_query($sql, $mysql_handler);
			
			$question_id = mysql_insert_id();
		
			$questionnaire_id = $_SESSION['active_questionnaire'];	
		
			$sql = "SELECT id FROM question_categories WHERE questionnaire_id = $questionnaire_id AND name = 'none'";
			$result = my_query($sql, $mysql_handler);
			
			$row = mysql_fetch_row($result);
			$category_none = $row['0'];
		
			$sql = "INSERT INTO in_category (category_id, question_id) VALUES ('$category_none', '$question_id')";
			my_query($sql, $mysql_handler);
		
			if($questiontype == "multiple_choice")
			{
				foreach($_SESSION['alternatives'] AS $key => $value)
				{
					$value = clean_string($value);
					$sort_order = $_SESSION['alt_order'][$key];
			
					$sql = "INSERT INTO question_alternatives (question_id, alternative, sort_order) VALUES ('$question_id', '$value', '$sort_order')";
					my_query($sql, $mysql_handler);
				}
		
				unset($_SESSION['alternatives']);
				unset($_SESSION['alt_order']);
				unset($_SESSION['question_text']);
				unset($_SESSION['several']);
			}
		
			print_back('manage_questions');
		}
		else
		{
			if(!isset($_REQUEST['questiontype'])) 
				$questiontype = 'gradedquestion';
			else 
				$questiontype = $_REQUEST['questiontype'];
		
			if(isset($_POST['submit']))
			{
				$status[] = array('type' => 'error', 'text' => "One or more fields are empty.", 'size' => 'normal');
				$error = 1;
			}

			if(!$error && !$ok && !error_to_report($status))
				$status[] = array('type' => 'description', 'text' => "Select the type of question you want to add and then enter the question text, check the \"Negate\" box if your question is negated. Ex. I'm not pleased with the course.");

			pageHeader($pagetitle, $path, $path_back, $status);
?>
		
		<form name="changequestion" method="post" action="index.php">
		<input type="hidden" name="page" value="action_append_question" />
		<table>
			<tr>
				<td><b>Question type:</b></td><td>&nbsp;</td>
			</tr>
			<tr>	
				<td>
					<select name="questiontype" class="dropdown" onchange="document.changequestion.submit()">
						<option value="gradedquestion"<?php if($questiontype == 'gradedquestion') echo(' selected="selected"'); ?>>Graded Question</option>
						<option value="textquestion"<?php if($questiontype == 'textquestion') echo(' selected="selected"'); ?>>Text Question</option>
						<option value="multiple_choice"<?php if($questiontype == 'multiple_choice') echo(' selected="selected"'); ?>>Multiple Choice  Question</option>
						<option value="number"<?php if($questiontype == 'number') echo(' selected="selected"'); ?>>Number Question</option>
					</select>
				</td>
				<td colspan="2"> 
					<input type="submit" id="type_of_q" class="button_green  button_wide" value="Change question type" />
				</td>
			</tr>
		</table>
		</form>
		
	<br />	
		<form name="zeus" method="post" action="index.php">
		<input type="hidden" name="page" value="action_append_question" />
		<input type="hidden" name="questiontype" value="<?php echo $questiontype; ?>" />
		<table>
		<?php
		
			if($questiontype == 'gradedquestion')
			{
		?>
				<tr>
					<td><b>Question text:</b></td>
					<td><b>Negated:</b></td>
				</tr>
				<tr>
					<td><input type="text" class="wide" name="question" /></td>
					<td><input type="checkbox" class="checkbox" name="negate" value="true"<?php if(isset($_POST['negate'])) echo "checked='checked'"; ?> /></td>
				</tr>
				<tr>
					<td><input type="submit" class="button_green button_normal" name="submit" value="Append" />&nbsp;<input type="submit" name="go_back" class="button_red  button_normal" value="Cancel" /></td>
				</tr>
		<?php
			}
			elseif($questiontype == 'textquestion')
			{
		?>
				<tr>
					<td><b>Question text:</b></td>
					<td><b>Number of rows:</b></td>
				</tr>
				<tr>
					<td><input type="text" class="wide" name="question" /></td>
					<td><input class="button_small" type="text" name="numb_rows" value="<?php if(isset($_POST['numb_rows'])) echo "'".get_print_value($_POST['numb_rows'])."'"; else echo '3'; ?>" /></td>
				</tr>
				<tr>
					<td colspan="2"><input type="submit" class="button_green button_normal" name="submit" value="Append" /></td>
				</tr>
		<?php
			}
			elseif($questiontype == 'number')
			{
		?>
				<tr>
					<td colspan="2"><b>Question text:</b></td>
				</tr>
				<tr>
					<td><input type="text" class="wide" name="question" /></td>
				</tr>
				<tr>
					<td><input type="submit" class="button_green button_normal" name="submit" value="Append" /></td>
				</tr>
		<?php
			}
			elseif($questiontype == 'multiple_choice')
			{
				if(isset($_SESSION['alternatives']))
					$alternatives = $_SESSION['alternatives'];
				else
					$alternatives  = array();
		
				if(isset($_SESSION['alt_order']))
					$alt_order = $_SESSION['alt_order'];
				else
					$alt_order  = array();
		
		?>
				<tr>
					<td colspan="2"><b>Question text:</b></td>
				</tr>
				<tr>
					<td colspan="2"><input type="text" class="wide" name="question" value="<?php echo get_print_value($_SESSION['question_text']); ?>"/><br /><input class="checkbox" id="several" type="checkbox" name="several" <?php if($_SESSION['several'] == "on") echo "checked=\"checked\""; ?> /><label for="several">Several answers possible</label></td>
				</tr>
				<tr>
					<td><br /><b>Alternatives:</b></td><td></td>
				</tr>
				<tr>
					<td valign="top">
						<select name="rows[]" class="small_choice"  multiple="multiple"  onchange="enable_object('modify');enable_object('delete');enable_object('move_up');enable_object('move_down');">
		<?php
							$arr = array();
							foreach($alt_order as $key => $order)
								$arr[$order] = $key;		
				
							$j = 0;
							for($i=1;$i<=count($arr);$i++)
							{
								if($j++ % 2)
									$class_c = 'odd';
								else
									$class_c = 'even';
	
								if(is_array($_POST['rows']))
								{
									if(in_array($arr[$i], $_POST['rows']))
										echo '<option selected="selected" class="'.$class_c.'" value="'.$arr[$i].'">'.get_print_value($alternatives[$arr[$i]])."</option>\n";
									else
										echo '<option class="'.$class_c.'" value="'.$arr[$i].'">'.get_print_value($alternatives[$arr[$i]])."</option>\n";
								}
								else
									echo '<option class="'.$class_c.'" value="'.$arr[$i].'">'.get_print_value($alternatives[$arr[$i]])."</option>\n";
							}
		?>
						</select>
					</td>
	<td valign="top">
						<input type="submit" class="button_blue button_normal"  name="append_alternative" value="Append" /><br />
						<input type="submit" class="button_blue button_normal"  name="modify_alternative" id="modify" value="Modify" /><br /><br />
						<input type="submit" class="button_blue button_normal"  name="delete_alternative" id="delete" value="Delete" /><br /><br />
						<input type="submit" class="button_blue button_normal"  name="up_alternative" id="move_up" value="Move Up" /><br />
						<input type="submit" class="button_blue button_normal"  name="down_alternative" id="move_down" value="Move Down" />
					</td>
				</tr>
				<tr>
					<td colspan="2">&nbsp;</td>
				</tr>
				<tr>
					<td colspan="2"><input type="submit" name="submit" class="button_green button_normal" value="Save" /></td>
				</tr>
		<?php
			}
		?>
		</table>
		</form>
		
		<?php
		}
		if(!isset($_POST['up_alternative']) && !isset($_POST['down_alternative']) && $questiontype == 'multiple_choice')
		{
		?>
			<script language="javascript" type="text/javascript"> disable_object('modify'); disable_object('move_down'); disable_object('delete'); disable_object('move_up');</script>
<?php
		}
	}
	?>
	
	<script language="javascript" type="text/javascript">
	
	document.getElementById('type_of_q').style.visibility = 'hidden';
	
	</script>
	<?php
	pageFooter();
}
?>
