<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

// Enter everything changed in change_questions into the session
if(isset($_POST['question']))
{
	foreach($_POST['question'] AS $key => $value)
	{
		$_SESSION['change_questions_data']['questions'][$key] = $value;	
	
		if(isset($_POST['negate'][$key]))
			$_SESSION['change_questions_data']['negate'][$key] = 1;
		else
			$_SESSION['change_questions_data']['negate'][$key] = 0;
		
		if(isset($_POST['numb_rows'][$key]))
			$_SESSION['change_questions_data']['number_of_rows'][$key] = $_POST['numb_rows'][$key];
		else
			$_SESSION['change_questions_data']['number_of_rows'][$key] = 3;

		if(isset($_POST['several'][$key]))
			$_SESSION['change_questions_data']['several'][$key] = 1; 
		else
			unset($_SESSION['change_questions_data']['several'][$key]);
	}
	$_SESSION['change_questions_data']['master'] = $_POST['master'];
}

// Print pathborder
$path[] = array('href' => return_href('manage_questionnaire'), 'name' => 'Manage: '.$_SESSION['active_questionnaire_name']);
$path[] = array('href' => return_href('manage_questions'), 'name' => 'Manage Questions');

if(count($_SESSION['change_questions_data']['questions']) == 1)
	$path[] = array('href' => return_href('change_questions'), 'name' => 'Modify Question');
else
	$path[] = array('href' => return_href('change_questions'), 'name' => 'Modify Questions');

// We know that $_POST['modify_alternative'] only has one $key.
if(is_array($_POST['modify_alternative']))
{
	foreach($_POST['modify_alternative'] AS $key => $bla)
		$q_id = $key;
}

if(!isset($q_id) && isset($_POST['q_id']))
	$q_id = $_POST['q_id'];


if(count($_POST['alt_rows'][$q_id]) == 1)
	$path[] = array('href' => '', 'name' => 'Change Question Alternative');
else
	$path[] = array('href' => '', 'name' => 'Change Question Alternative');

$path_back = return_href('change_questions');


if((isset($_POST['modify_alternative']) && !isset($_POST['alt_rows'][$q_id])) || isset($_POST['cancel']))
{
	print_back('change_questions');
}

elseif(isset($_POST['change']))
{
	foreach($_POST['alternative'] AS $key => $name)
	{
		if(!empty($name))
		{
			$_SESSION['change_questions_data']['multiple_choice'][$q_id][$key] = $name;
		}
	}
	print_back('change_questions');
}
elseif(is_array($_POST['alt_rows'][$q_id]) && !isset($_POST['cancel']))
{

	if(count($_POST['alt_rows'][$q_id]) == 1)
	{
		$pagetitle = 'Modify Question Alternative';
		$status[] = array('type' => 'description', 'text' => 'Enter a new text for the alternative.');
	}
	else
	{
		$pagetitle = 'Modify Question Alternatives';
		$status[] = array('type' => 'description', 'text' => 'Enter new texts for the question alternatives.');
	}
	pageHeader($pagetitle, $path, $path_back, $status);
	?>
	<form name="change_categories" action="index.php" method="post">
	<input type="hidden" name="page" value="change_change_questions_alternative" />
	<input type="hidden" name="q_id" value="<?php echo $q_id; ?>" />
	<table>
		<tr>
			<td><b>Text of alternative:</b></td>
		</tr>
	<?php
	foreach($_POST['alt_rows'][$q_id] AS $key)
	{
	?>
		<tr>
			<td><input type="text" name="alternative[<?php echo $key; ?>]" value="<?php echo get_print_value($_SESSION['change_questions_data']['multiple_choice'][$q_id][$key]); ?>" /></td>
		</tr>
	<?php
	}
	?>
		<tr>
			<td><br /><input type="submit" name="change" class="button_green button_normal" value="Change" />&nbsp;<input type="submit" class="button_red button_normal" name="cancel" value="Cancel" /></td>
		</tr>
	</table>
	</form>
<?php
	pageFooter();
}
?>