<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

$folders_are = 0;
$files_are = 0;
$new = 0;

if(isset($_SESSION['files_and_folders']))
{
	if(isset($_POST['page']) && $_POST['page'] == "change_filetree" && !isset($_POST['cancel']))
	{
		unset($_SESSION['files_and_folders']);
		$_SESSION['files_and_folders']['file'] = array();
		$_SESSION['files_and_folders']['folder'] = array();

		if(isset($_POST['file']))
		{
			foreach($_POST['file'] AS $id => $name)
			{
				if(is_numeric($id))
				{
					$_SESSION['files_and_folders']['file'][$id] = $name;
				}
			}
		}
		if(isset($_POST['folder']))
		{
			foreach($_POST['folder'] AS $id => $name)
			{
				if(is_numeric($id))
				{
					$_SESSION['files_and_folders']['folder'][$id] = $name;
				}
			}
			$new = 1;
		}
	}
}
else
	print_back('manage_questionnaires');

if(isset($_POST['rename']))
{
	$empty = 0;
	foreach($_SESSION['files_and_folders']['file'] AS $id => $name)
	{
		if($name == "")
			$empty = 1;
	}
	foreach($_SESSION['files_and_folders']['folder'] AS $id => $name)
	{
		if($name == "")
			$empty = 1;
	}

	if($empty)
		$status[] = array('type' => 'error', 'text' => 'All questionnaires and folders has to have a name.');
	else
	{
		if(count($_SESSION['files_and_folders']['file']) > 0)
		{
			foreach($_SESSION['files_and_folders']['file'] AS $id => $name)
			{
				if(is_numeric($id))
				{
					$sql = "UPDATE questionnaires SET name='".clean_string($name)."' WHERE id = $id";
					my_query($sql, $mysql_handler);
				}
			}
		}
		if(count($_SESSION['files_and_folders']['folder']) > 0)
		{
			foreach($_SESSION['files_and_folders']['folder'] AS $id => $name)
			{
				if(is_numeric($id))
				{
					$sql = "UPDATE folders_questionnaires SET name='".clean_string($name)."' WHERE id = $id";
					my_query($sql, $mysql_handler);
				}
			}
		}
		
		print_back('manage_questionnaires');
	}
}
elseif(isset($_POST['cancel']))
{
	//cancel
	print_back('manage_questionnaires');
}

if($new)
{
	foreach($_SESSION['files_and_folders']['file'] AS $id => $name)
	{
		$files_are = 1;
	}
	foreach($_SESSION['files_and_folders']['folder'] AS $id => $name)
	{
		$folders_are = 1;
	}
}
else
{
	foreach($_SESSION['files_and_folders']['file'] AS $id)
	{
		$files_are = 1;
	}
	foreach($_SESSION['files_and_folders']['folder'] AS $id)
	{
		$folders_are = 1;
	}
}

if(!error_to_report($status))
{
	if($files_are && $folders_are)
		$status[] = array('type' => 'description', 'text' => 'Enter the new names of the questionnaires and folders.');
	elseif($folders_are)
		$status[] = array('type' => 'description', 'text' => 'Enter the new names of the folders.');
	elseif($files_are)
		$status[] = array('type' => 'description', 'text' => 'Enter the new names of the questionnaires.');
}	

// Print pathborder
$path[] = array('href' => '', 'name' => 'Rename');
$path_back = return_href('manage_questionnaires');

$pagetitle = "Rename";

pageHeader($pagetitle, $path, $path_back, $status);

?>
<form name="rename_filetree" action="index.php" method="post">
<input type="hidden" name="page" value="change_filetree" />
<table>
<?php

if($new)
{
	if(count($_SESSION['files_and_folders']['file']) > 0)
	{
		echo "<tr><td><b>Questionnaires</b><br /></tr></td>";
		foreach($_SESSION['files_and_folders']['file'] AS $id => $name)
		{
			if(is_numeric($id))
			{
				$sql = "SELECT name FROM questionnaires WHERE id = $id";
		
				$result = my_query($sql, $mysql_handler);
				$data = mysql_fetch_assoc($result);
		
				?>
				<tr>
					<td><input type="text" name="file[<?php echo $id; ?>]" value="<?php echo get_print_value($name); ?>" /></td>
				</tr>
				<?php
			}
		}
	}
	if(count($_SESSION['files_and_folders']['folder']) > 0)
	{
		echo "<tr><td>Folders<br /></tr></td>";
		foreach($_SESSION['files_and_folders']['folder'] AS $id => $name)
		{
			if(is_numeric($id))
			{
				$sql = "SELECT name FROM folders_questionnaires WHERE id = $id";
		
				$result = my_query($sql, $mysql_handler);
				$data = mysql_fetch_assoc($result);
		
				?>
				<tr>
					<td><input type="text" name="folder[<?php echo $id; ?>]" value="<?php echo get_print_value($name); ?>" /></td>
				</tr>
				<?php
			}
		}
	}
}
else
{
	if(count($_SESSION['files_and_folders']['file']) > 0)
	{
		echo "<tr><td><b>Questionnaires</b><br /></tr></td>";
		foreach($_SESSION['files_and_folders']['file'] AS $id)
		{
			if(is_numeric($id))
			{
				$sql = "SELECT name FROM questionnaires WHERE id = $id";
		
				$result = my_query($sql, $mysql_handler);
				$data = mysql_fetch_assoc($result);
		
				?>
				<tr>
					<td><input type="text" name="file[<?php echo $id; ?>]" value="<?php echo get_print_value($data['name']); ?>" /></td>
				</tr>
				<?php
			}
		}
	}
	if(count($_SESSION['files_and_folders']['folder']) > 0)
	{
		echo "<tr><td><b>Folders</b><br /></tr></td>";
		foreach($_SESSION['files_and_folders']['folder'] AS $id)
		{
			if(is_numeric($id))
			{
				$sql = "SELECT name FROM folders_questionnaires WHERE id = $id";
		
				$result = my_query($sql, $mysql_handler);
				$data = mysql_fetch_assoc($result);
		
				?>
				<tr>
					<td><input type="text" name="folder[<?php echo $id; ?>]" value="<?php echo get_print_value($data['name']); ?>" /></td>
				</tr>
				<?php
			}
		}
	}
}

?>
	<tr>
		<td align="right"><br /><input type="submit" name="rename" class="button_green button_normal" value="Change" />&nbsp;<input type="submit" class="button_red button_normal" name="cancel" value="Cancel" /></td>
	</tr>
</table>
</form>
<?php

pageFooter();
?>