<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: change_properties.inc.php,v 1.30 2006/06/07 14:56:46 medea7 Exp $
*/

// Print pathborder
$path[] = array('href' => return_href('maintenance'), 'name' => 'System maintenance');
$path[] = array('href' => '', 'name' => 'Change site properties');
$path_back = return_href('maintenance');

$pagetitle = 'Change Properties';

if($_SESSION['superuser'])
{

	if(isset($_REQUEST['cancel']))
	{
		print_back('maintenance');
	}
	else
	{
		if(!empty($_POST['save_site_properties']) && !empty($_POST['site_title']))
		{
			$site_org = clean_string($_POST['site_org']);
			$site_send_publish_mail = clean_string($_POST['site_send_publish_mail']);
			$site_smtp = clean_string($_POST['site_smtp']);
			$manage_name = clean_string($_POST['manage_name']);
			$manage_email = clean_string($_POST['manage_email']);
			$site_title = clean_string($_POST['site_title']);
			$site_desc = clean_string($_POST['site_desc']);
			$color_box_1 = clean_string(str_replace("#", "", $_POST['color_box_1']));
			$color_box_2 = clean_string(str_replace("#", "", $_POST['color_box_2']));
			$site_user_site = clean_string($_POST['site_user_site']);
			$site_admin_site = clean_string($_POST['site_admin_site']);
	
			if(empty($site_org) || (!empty($site_send_publish_mail) && empty($site_smtp)) || empty($manage_name) || empty($manage_email) || empty($site_title) || empty($color_box_1) || empty($color_box_2))
			{
				$status[] = array('type' => 'error', 'text' => 'You have to fill in all the fields except description!');
			}
			elseif(!preg_match('/^http[s]?:\/\//i', $site_user_site) || !preg_match('/^http[s]?:\/\//i', $site_admin_site))
			{
				$status[] = array('type' => 'error', 'text' => 'Site URLs must start with http[s]://');
			}
			else
			{
				$sql = "UPDATE site_properties SET site_admin_site = '$site_admin_site', site_user_site = '$site_user_site', site_org = '$site_org', site_send_publish_mail = '$site_send_publish_mail', site_smtp = '$site_smtp', site_manager = '$manage_name', site_manager_email='$manage_email', site_title = '$site_title', site_desc = '$site_desc', question_row_color1 = '#$color_box_1', question_row_color2 = '#$color_box_2', site_user_site = '$site_user_site', site_admin_site = '$site_admin_site' WHERE id = 1 LIMIT 1";
				$commit = my_query($sql, $mysql_handler);
			
				$status[] = array('type' => 'ok', 'text' => 'Your settings where saved.');
	
				
			}
		}
	
		$sql = "SELECT * FROM site_properties";
		$result = my_query($sql, $mysql_handler);
		$site_results = mysql_fetch_assoc($result); 
		
		?>
		<?php
		if(!error_to_report)
			$status[] = array('type' => 'description', 'text' => 'Change system properties.');
	
		pageHeader($pagetitle, $path, $path_back, $status);
	
		
	
		?>
		<form name="properties" method="post" action="index.php">
			<input type="hidden" name="page" value="change_properties" />
			<table>
				<tr><td colspan="2"><b>Site&nbsp;properties</b></td></tr>
				<tr>
					<td align="right">Site title:</td>
					<td align="right"><input type="text" class="wide" name="site_title" value="<?php if(isset($_POST['site_title'])) echo get_print_value($_POST['site_title']); else echo get_print_value($site_results['site_title']); ?>" size="30" /></td>
				</tr>
				<tr>
					<td align="right">Site description:</td>
					<td align="right"><textarea name="site_desc" class="wide" cols="30" rows="5"><?php if(isset($_POST['site_desc'])) echo get_print_value($_POST['site_desc']); else echo get_print_value($site_results['site_desc']); ?></textarea></td>
				</tr>		
				<tr>
					<td align="right">Organisation:</td>
					<td align="right"><input type="text" class="wide" name="site_org" value="<?php if(isset($_POST['site_org'])) echo get_print_value($_POST['site_org']); else echo get_print_value($site_results['site_org']); ?>" size="30" /></td>
				</tr>	
				<tr>
					<td align="right">SMTP-server:</td>
					<td align="right"><input type="text" class="wide" name="site_smtp" value="<?php if(isset($_POST['site_smtp'])) echo get_print_value($_POST['site_smtp']); else echo get_print_value($site_results['site_smtp']); ?>" size="30" /></td>
				</tr>
				<tr>
					<td colspan="2" align="right"><input id="site_send_publish_mail" type="checkbox" value="1" class="checkbox" name="site_send_publish_mail"<?php if(isset($_POST['site_send_publish_mail'])) echo 'checked="checked"'; elseif($site_results['site_send_publish_mail']) echo 'checked="checked"'; ?> /><label for="site_send_publish_mail">Send email when a questionnaire is published</label></td>
				</tr>
				<tr>
					<td align="right">Admin URL:</td>
					<td align="right"><input type="text" name="site_admin_site" class="wide" value="<?php if(isset($_POST['site_admin_site'])) echo get_print_value($_POST['site_admin_site']); else echo get_print_value($site_results['site_admin_site']); ?>" size="30" /></td>
				</tr>
				<tr>
					<td align="right">User URL:</td>
					<td align="right"><input type="text" name="site_user_site" class="wide" value="<?php if(isset($_POST['site_user_site'])) echo get_print_value($_POST['site_user_site']); else echo get_print_value($site_results['site_user_site']); ?>" size="30" /></td>
				</tr>
				<tr>
					<td colspan="2"><b>Question properties</b></td>
				</tr>
				<tr>
					<td align="right" id="color1">Row color 1:</td>
					<td align="right">#<input type="text" name="color_box_1" class="wide" id="color_box_1" onchange="prew_color('color1', 'color_box_1');" size="7" maxlength="7" value="<?php if(isset($_POST['color_box_1'])) echo get_print_value($_POST['color_box_1']); else echo get_print_value(str_replace("#", "", $site_results['question_row_color1'])); ?>" /></td>
				</tr>
				<tr>
					<td align="right" id="color2">Row color 2:</td>
					<td align="right">#<input type="text" name="color_box_2" class="wide" size="7" onchange="prew_color('color2', 'color_box_2');" id="color_box_2" maxlength="7" value="<?php if(isset($_POST['color_box_2'])) echo get_print_value($_POST['color_box_2']); else echo get_print_value(str_replace("#", "", $site_results['question_row_color2'])); ?>" /></td>
				</tr>
		
				<tr>
					<td colspan="2"><b>Site Manager properties</b></td>
				</tr>
				<tr>
					<td align="right">Site manager name:</td>
					<td align="right"><input type="text" name="manage_name" class="wide" value="<?php if(isset($_POST['manage_name'])) echo get_print_value($_POST['manage_name']); else echo get_print_value($site_results['site_manager']); ?>" /></td>
				</tr>
				<tr>
					<td align="right">Site manager e-mail:</td>
					<td align="right"><input type="text" name="manage_email" class="wide" value="<?php if(isset($_POST['manage_email'])) echo get_print_value($_POST['manage_email']); else echo get_print_value($site_results['site_manager_email']); ?>" /></td>
				</tr>	
				<tr><td colspan="2" align="right"><input  type="submit" class="button_green  button_normal" name="save_site_properties" value="Save" />&nbsp;<input type="submit" name="cancel" class="button_red button_normal" value="Cancel" /></td></tr>
			</table>
		
		
		</form>
		<script language="javascript"  type="text/javascript">document.getElementById('color1').style.background = '<?php echo $site_results['question_row_color1']; ?>';document.getElementById('color2').style.background = '<?php echo $site_results['question_row_color2']; ?>';</script>
		<?php
	}
	pageFooter();
}
else
{
	$status[] = array('type' => 'error', 'text' => 'You are not allowed to view this page.', 'size' => 'normal');
	pageHeader($pagetitle, $path, $path_back, $status);
	pageFooter();
}
?>