<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: change_questions.inc.php,v 1.43 2006/06/07 11:47:18 medea8 Exp $
*/

$one_selected = 0;

if(is_numeric($_SESSION['active_questionnaire']))
{
	// Enter everything changed in change_questions into the session
	if(isset($_POST['question']))
	{
		foreach($_POST['question'] AS $key => $value)
		{
			$_SESSION['change_questions_data']['questions'][$key] = $value;	
		
			if(isset($_POST['negate'][$key]))
				$_SESSION['change_questions_data']['negate'][$key] = 1;
			else
				$_SESSION['change_questions_data']['negate'][$key] = 0;
			
			if(isset($_POST['numb_rows'][$key]))
				$_SESSION['change_questions_data']['number_of_rows'][$key] = $_POST['numb_rows'][$key];
			else
				$_SESSION['change_questions_data']['number_of_rows'][$key] = 3;
	
			if(isset($_POST['several'][$key]))
				$_SESSION['change_questions_data']['several'][$key] = 1; 
			else
				unset($_SESSION['change_questions_data']['several'][$key]);
		}
		$_SESSION['change_questions_data']['master'] = $_POST['master'];
	}
	
	
	if(isset($_SESSION['change_questions_data']['master']))
		$master_question = $_SESSION['change_questions_data']['master'];
	else
	{
		$sql = "SELECT master_question FROM questionnaires WHERE id = ".$_SESSION['active_questionnaire'];
		$result = my_query($sql, $mysql_handler);
		$master_question = mysql_fetch_row($result);
		$master_question = $master_question[0];
	}
	
	// Print pathborder
	$path[] = array('href' => return_href('manage_questionnaire'), 'name' => 'Manage: '.$_SESSION['active_questionnaire_name']);
	$path[] = array('href' => return_href('manage_questions'), 'name' => 'Manage Questions');
	
	if(count($_POST['rows']) == 1 || count($_SESSION['change_questions_data']['questions']) == 1)
		$path[] = array('href' => '', 'name' => 'Modify Question');
	else
		$path[] = array('href' => '', 'name' => 'Modify Questions');
	
	$path_back = return_href('manage_questions');
	
	if(count($_POST['rows']) == 1 || count($_SESSION['change_questions_data']['questions']) == 1)
		$pagetitle = 'Modify Question';
	else
		$pagetitle = 'Modify Questions';
	
	if(!$_SESSION['owner_questionnaire'])
	{
		$status[] = array('type' => 'error', 'text' => 'Only the owner of a questionnaire can change questions in the questionnaire!');
	}
	else
	{	
		if((is_array($_POST['question'])) && isset($_POST['submit_changes']))
		{
			$empty_fields_no_save = 1;
			if(is_array($_SESSION['change_questions_data']['multiple_choice']))
			{
				foreach($_SESSION['change_questions_data']['multiple_choice'] AS $key)
				{
					$empty_fields_no_save = 0;
				}
			}
			else
				$empty_fields_no_save = 0;
			
			foreach($_POST['question'] AS $key => $text)
			{
				if(empty($text)) $empty_fields_no_save = 1;
				
				if(isset($_POST['numb_rows'][$key]) && !error_to_report($status))
					if(isset($_POST['numb_rows'][$key]) && !(is_numeric($_POST['numb_rows'][$key]) && $_POST['numb_rows'][$key] > 0 && $_POST['numb_rows'][$key] % 1 == 0))
						{
							$status[] = array('type' => 'error', 'text' => 'Number of rows has to be a number larger than 0.');
						}
			}
			
			if(!$empty_fields_no_save && !error_to_report($status))
			{
				foreach($_POST['question'] AS $key => $text)
				{
					if(is_numeric($key))
					{
						if($_POST['negate'][$key]==true)
							$negate = 1;
						else
							$negate = 0;
				
						if(isset($_POST['numb_rows'][$key]))
							$row_var = $_POST['numb_rows'][$key];
						else
							$row_var = 3;
						
						if(isset($_POST['several'][$key]))
							$several = 1;
						else
							$several = 0;
			
						if(!empty($text))
						{
							$text = clean_string($text);
							if(is_numeric($row_var))
							{
								$sql = "UPDATE questions SET name = '$text', negate = $negate, number_of_rows = $row_var, several = $several WHERE id = $key";
								my_query($sql,$mysql_handler);
							}
						}
						if(isset($_POST['master']))
						{
							if(is_numeric($_POST['master']))
							{
								$sql = 'UPDATE questionnaires SET master_question = '.$_POST['master']. ' WHERE id = '.$_SESSION['active_questionnaire'].';';
								my_query($sql,$mysql_handler);
							}
						}
					}
				}
				
			
				
				if(is_array($_SESSION['change_questions_data']['multiple_choice']))
				{
					foreach($_SESSION['change_questions_data']['multiple_choice'] AS $q_id => $bla)
					{
						if(is_numeric($q_id))
						{
							foreach($_SESSION['change_questions_data']['multiple_choice'][$q_id] AS $key => $alternative)
							{
								if(!empty($alternative) && is_numeric($key))
								{
									$alternative = clean_string($alternative);
									$sort_order = $_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$key];
									
									if(is_numeric($sort_order))
									{
										if(isset($_SESSION['change_questions_data']['multiple_choice_insert']) && in_array($key, $_SESSION['change_questions_data']['multiple_choice_insert']))
										{
											$sql = "INSERT INTO question_alternatives (question_id, alternative, sort_order) VALUES ($q_id, '$alternative', $sort_order)";
											my_query($sql, $mysql_handler);
										}
										else
										{
											$sql = "UPDATE question_alternatives SET alternative = '$alternative', sort_order = $sort_order WHERE id = $key";
											my_query($sql, $mysql_handler);
										}
									}
								}	
							}
						}
					}
				}
				
				if(is_array($_SESSION['change_questions_data']['multiple_choice_delete']))
				{
					foreach($_SESSION['change_questions_data']['multiple_choice_delete'] AS $key)
					{
						if(is_numeric($key))
						{
							$sql = "DELETE FROM question_alternatives WHERE id = $key LIMIT 1";
							my_query($sql, $mysql_handler);
						}
					}
				}
				print_back('manage_questions');
			}
			else
			{
				$status[] = array('type' => 'error', 'text' => 'You cant save questions with no name.');
			}
		}
		
		if(isset($_POST['delete_alternative']))
		{
			// We know that $_POST['delete_alternative'] only has one $key. 
			foreach($_POST['delete_alternative'] AS $key => $value)
				$q_id = $key;
		
			foreach($_POST['alt_rows'][$q_id] AS $key)
			{
				unset($_SESSION['change_questions_data']['multiple_choice'][$q_id][$key]);
				
				$p = $_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$key];
		
				foreach($_SESSION['change_questions_data']['multiple_choice_order'][$q_id] AS $id => $order)
				{	
					if($order > $p)
						$_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$id]--;
		
				}
		
				unset($_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$key]);
		
				if(is_array($_SESSION['change_questions_data']['multiple_choice_insert']))
				{	
					if(in_array($key, $_SESSION['change_questions_data']['multiple_choice_insert']))
					{
						foreach($_SESSION['change_questions_data']['multiple_choice_insert'] AS $k => $v)
						{
							if($v == $key)
								unset($_SESSION['change_questions_data']['multiple_choice_insert'][$k]);
						}
					}
				}
				else
					$_SESSION['change_questions_data']['multiple_choice_delete'][] = $key;
			}
		}
		
		if(isset($_POST['up_alternative']))
		{
			// We know that $_POST['up_alternative'] only has one $key. 
			foreach($_POST['up_alternative'] AS $key => $value)
				$q_id = $key;
		
			if(is_array($_POST['alt_rows'][$q_id]))
			{
				foreach($_POST['alt_rows'][$q_id] AS $id)
				{
					unset($yay);
					$p = $_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$id];
					foreach($_SESSION['change_questions_data']['multiple_choice_order'][$q_id] AS $key => $pos)
					{
						if($pos == $p - 1)
							$yay = $key;
					}
					if(isset($yay))
					{
						$_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$id]--;
						$_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$yay]++;
			
					}
			
				}
			}
		
		}
		
		if(isset($_POST['down_alternative']))
		{
			// We know that $_POST['down_alternative'] only has one $key. 
			foreach($_POST['down_alternative'] AS $key => $value)
				$q_id = $key;
		
			if(is_array($_POST['alt_rows'][$q_id]))
			{
				foreach(array_reverse($_POST['alt_rows'][$q_id]) AS $id)	
				{
					unset($yay);
					$p = $_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$id];
					foreach($_SESSION['change_questions_data']['multiple_choice_order'][$q_id] AS $key => $pos)
					{
						if($pos == ($p + 1))
							$yay = $key;
					}
					if(isset($yay))
					{
						$_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$id]++;
						$_SESSION['change_questions_data']['multiple_choice_order'][$q_id][$yay]--;
			
					}
				}
			}
		
		}
		
		
		if(is_array($_POST['rows']) || is_array($_SESSION['change_questions_data']['questions']))
		{
			if(count($_POST['rows']) == 1 || count($_SESSION['change_questions_data']['questions']) == 1)
			{
				if(!error_to_report($status))
					$status[] = array('type' => 'description', 'text' => 'Modify the selected question. The changes made will be saved when you click on the "Change" button.');
			}
			else
			{
				if(!error_to_report($status))
					$status[] = array('type' => 'description', 'text' => 'Modify the selected questions. The changes made will be saved when you click on the "Change" button.');
			}
		
			if(isset($_POST['rows']))
			{
				foreach($_POST['rows'] AS $id)
				{
					if(is_numeric($id))
					{
						$sql = "SELECT questiontype, name, negate, number_of_rows, several FROM questions WHERE id = $id";
						$result = my_query($sql, $mysql_handler);
						$data = mysql_fetch_assoc($result);
					
						// Build session data. 
						$_SESSION['change_questions_data']['questions'][$id] = $data['name'];
			
						if($id == $master_question)
							$_SESSION['change_questions_data']['master'] = $id;
			
						$_SESSION['change_questions_data']['negate'][$id] = $data['negate'];
				
						if($data['number_of_rows'] > 0)
							$_SESSION['change_questions_data']['number_of_rows'][$id] = $data['number_of_rows'];
						else
							$_SESSION['change_questions_data']['number_of_rows'][$id] = 3;
			
						if($data['several'])
							$_SESSION['change_questions_data']['several'][$id] = $data['several'];
		
						// Sort questions based on questiontype. One array per type.
						if($data['questiontype'] == "gradedquestion")
							$gradedquestion[] = $id;
						
						elseif($data['questiontype'] == "textquestion")
							$textquestion[] = $id;
					
						elseif($data['questiontype'] == "multiple_choice")
							$multiple_choice[] = $id;
						
						elseif($data['questiontype'] == "number")
							$number[] = $id;
					}	
				}
			}
			elseif(is_array($_SESSION['change_questions_data']['questions']))
			{
				foreach($_SESSION['change_questions_data']['questions'] AS $id => $value)
				{
					if(is_numeric($id))
					{
						$sql = "SELECT questiontype FROM questions WHERE id = $id";
						$result = my_query($sql, $mysql_handler);
						$data = mysql_fetch_assoc($result);
				
				
						// Sort questions based on questiontype. One array per type.	
						if($data['questiontype'] == "gradedquestion")
							$gradedquestion[] = $id;
						
						elseif($data['questiontype'] == "textquestion")
							$textquestion[] = $id;
					
						elseif($data['questiontype'] == "multiple_choice")
							$multiple_choice[] = $id;
			
						elseif($data['questiontype'] == "number")
							$number[] = $id;
					}
				}
			}
			pageHeader($pagetitle, $path, $path_back, $status);
?>
			<form name="change_questions" action="index.php" method="post">
			<input type="hidden" name="page" value="action_change_questions" />
			<?php
			if(count($gradedquestion) > 0)
			{
			?>
				<table>
					<tr>
						<td colspan="3"><h3><br/>Graded Questions</h3></td>
					</tr>
					<tr>
						<td><b>Question text</b></td>
						<td><b>Negate</b></td>
						<td><b>Master question</b></td>
					</tr>
			
				<?php
				foreach($gradedquestion AS $id)
				{
					if(is_numeric($id))
					{
						$sql = "SELECT name, negate, questiontype FROM questions WHERE id = $id";
						$result = my_query($sql ,$mysql_handler);
						$row = mysql_fetch_assoc($result);
				
					?>
						
						<tr>
							<td><input type="text" class="wide" name="question[<?php echo($id); ?>]" value="<?php echo get_print_value($_SESSION['change_questions_data']['questions'][$id]); ?>" /></td>
							
							<td align="center"><input type="checkbox" class="checkbox" name="negate[<?php echo($id); ?>]" value="true" <?php 
							if(!empty($_SESSION['change_questions_data']['negate'][$id]))
								echo 'checked="checked"'; ?> /></td>
						
							<td align="center"><input class="radio" type="radio" <?php if($id == $master_question) echo 'checked="checked"'; ?> name="master" value="<?php echo($id); ?>" /></td>
				
						</tr>
					<?php
					}
				}
				?>
				</table>
			<?php
			}
			
			if(count($textquestion) > 0)
			{
			?>
				<table>
					<tr>
						<td><h3><br/>Text Questions</h3></td>
						<td></td>
					</tr>
					<tr>
						<td><b>Question text</b></td>
						<td><b>Number of rows:</b></td>
					</tr>
		
		
			
				<?php
				foreach($textquestion AS $id)
				{
					?>
					<tr>
						<td><input type="text" class="wide" name="question[<?php echo($id); ?>]" value="<?php 
						echo get_print_value($_SESSION['change_questions_data']['questions'][$id]); ?>" /></td><td><input class="short" type="text" name="numb_rows[<?php echo($id); ?>]" value="<?php 
						echo get_print_value($_SESSION['change_questions_data']['number_of_rows'][$id]); ?>" /></td>
					</tr>
					<?php
				}
				?>
				</table>
			<?php
			}
		
			if(count($multiple_choice) > 0)
			{
				foreach($multiple_choice AS $id)
				{
					if(is_numeric($id))
					{
						$sql = "SELECT name FROM questions WHERE id = $id";
						$result = my_query($sql ,$mysql_handler);
						$row = mysql_fetch_assoc($result);
						?>
						<table>
						<tr>
							<td colspan="2"><h3><br/>Multiple Choice Question</h3></td>
						</tr>
						<tr>
							<td><b>Question text</b></td><td><b>Several answers possible</b></td>
						</tr>
						<tr>
							<td>
		
							<input type="text" class="wide" name="question[<?php echo($id); ?>]" value="<?php
							echo get_print_value($_SESSION['change_questions_data']['questions'][$id]); ?>" />
							
							</td>
		
							<td>
							
							<input type="checkbox" class="checkbox" name="several[<?php echo($id); ?>]" <?php if(isset($_SESSION['change_questions_data']['several'][$id])) echo "checked=\"checked\"";?> />
		
							</td>
						</tr>
						<tr>
							<td>
							
						<?php
								if(!isset($_SESSION['change_questions_data']['multiple_choice'][$id]) || !isset($_SESSION['change_questions_data']['multiple_choice_order'][$id]))
								{
									$sql = "SELECT * FROM question_alternatives WHERE question_id = $id ORDER BY sort_order";
									$result = my_query($sql ,$mysql_handler);
			
									while($data = mysql_fetch_assoc($result))
									{
										$_SESSION['change_questions_data']['multiple_choice'][$id][$data['id']] = $data['alternative'];
			
										$_SESSION['change_questions_data']['multiple_choice_order'][$id][$data['id']] = $data['sort_order'];
									}
								}
			
								$alt_order = $_SESSION['change_questions_data']['multiple_choice_order'][$id];
								$alternatives = $_SESSION['change_questions_data']['multiple_choice'][$id];
								
							?>
								<table style="margin-left: 30px;">
									<tr>
										<td colspan="2"><b>Alternatives:</b></td>
									</tr>
									<tr>
						
										<td valign="top">
											<select name="alt_rows[<?php echo $id; ?>][]" multiple="multiple" onchange="enable_object('modify<?php echo $id; ?>');enable_object('delete<?php echo $id; ?>');enable_object('move_up<?php echo $id; ?>');enable_object('move_down<?php echo $id; ?>');">
											<?php
												$arr = array();
												foreach($alt_order as $key => $order)
													$arr[$order] = $key;		
									
												$j = 0;
												for($i=1; $i<=count($arr); $i++)
												{
													if($j++ % 2)
														$class_c = 'odd';
													else
														$class_c = 'even';
													
													if(isset($_POST['alt_rows'][$id]))
													{
														if(in_array($arr[$i],$_POST['alt_rows'][$id]))
														{
															echo '<option selected="selected" class="'.$class_c.'" value="'.$arr[$i].'">'.get_print_value($alternatives[$arr[$i]])."</option>\n";
															$one_selected = 1;
														}
														else
															echo '<option class="'.$class_c.'" value="'.$arr[$i].'">'.get_print_value($alternatives[$arr[$i]])."</option>\n";
													
													}
													else
														echo '<option class="'.$class_c.'" value="'.$arr[$i].'">'.get_print_value($alternatives[$arr[$i]])."</option>\n";
													
												}
											?>
											</select>
										</td>
										<td valign="top">
											<input type="submit" class="button_blue button_normal"  name="append_alternative[<?php echo $id; ?>]" value="Append" /><br />
											<input type="submit" class="button_blue button_normal"  name="modify_alternative[<?php echo $id; ?>]" id="modify<?php echo $id; ?>" value="Modify" /><br /><br />
											<input type="submit" class="button_blue button_normal"  name="delete_alternative[<?php echo $id; ?>]" id="delete<?php echo $id; ?>" value="Delete" /><br /><br />
											<input type="submit" class="button_blue button_normal"  name="up_alternative[<?php echo $id; ?>]" id="move_up<?php echo $id; ?>" value="Move Up" /><br />
											<input type="submit" class="button_blue button_normal"  name="down_alternative[<?php echo $id; ?>]" id="move_down<?php echo $id; ?>" value="Move Down" />
										</td>
									</tr>
				
								</table>
							</td>
						</tr>
						<tr><td>&nbsp;</td></tr>	
			
						</table>
						<?php
						if(!isset($_POST['up_alternative'][$id]) && !isset($_POST['down_alternative'][$id]))
						{
							if(!$one_selected)
							{
								?>
								<script language="javascript" type="text/javascript"> disable_object('modify<?php echo $id; ?>'); disable_object('move_down<?php echo $id; ?>'); disable_object('delete<?php echo $id; ?>'); disable_object('move_up<?php echo $id; ?>');</script>
								<?php
							}
						}
					}
				}
				?>
				
			<?php
			}
		
			if(count($number) > 0)
			{
			?>
				<table>
					<tr>
						<td><h3></br >Number Questions</h3></td>
					</tr>
					<tr>
						<td><b>Question text</b></td>
					</tr>
			
				<?php
				foreach($number AS $id)
				{
					if(is_numeric($id))
					{
						$sql = "SELECT name FROM questions WHERE id = $id";
						$result = my_query($sql ,$mysql_handler);
						$row = mysql_fetch_assoc($result);
				
					?>
						<tr>
							<td><input type="text" class="wide" name="question[<?php echo($id); ?>]" value="<?php 
							echo get_print_value($_SESSION['change_questions_data']['questions'][$id]); ?>" /></td>
						</tr>
					<?php
					}
				}
				?>
				</table>
			<?php
			}
		
		
		
			?>
			<br /><br />
			<input type="submit" class="button_green button_normal" name="submit_changes" value="Change" />&nbsp;<input type="submit" name="go_back" class="button_red button_normal" value="Cancel" />
		
			</form>
			<?php
			pageFooter();
		}
		else
			print_back('manage_questions');
	}
}
?>