<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: change_user.inc.php,v 1.13 2006/06/07 12:57:38 medea1 Exp $
*/

// Print pathborder
$path[] = array('href' => return_href('manage_questionnaire'), 'name' => 'Manage: '.$_SESSION['active_questionnaire_name']);
$path[] = array('href' => return_href('manage_questionnaire_users'), 'name' => 'Manage Users');
$path[] = array('href' => '', 'name' => 'Modify');
$path_back = return_href('manage_users');

$folders_are = 0;
$files_are = 0;
$new = 0;

if(isset($_SESSION['modify_users']))
{
	if(isset($_POST['page']) && $_POST['page'] == "change_user" && !isset($_POST['cancel']))
	{
		unset($_SESSION['modify_users']);
		$_SESSION['modify_users']['file'] = array();
		$_SESSION['modify_users']['folder'] = array();

		if(isset($_POST['filename']))
		{
			foreach($_POST['filename'] AS $id => $name)
			{
				if(is_numeric($id))
				{
					$_SESSION['modify_users']['file'][$id]['name'] = $name;
				}
			}
			foreach($_POST['fileemail'] AS $id => $name)
			{
				if(is_numeric($id))
				{
					$_SESSION['modify_users']['file'][$id]['email'] = $name;
				}
			}
			foreach($_POST['filepassword'] AS $id => $name)
			{
				if(is_numeric($id))
				{
					$_SESSION['modify_users']['file'][$id]['password'] = $name;
				}
			}
			$new = 1;
		}
		if(isset($_POST['folder']))
		{
			foreach($_POST['folder'] AS $id => $name)
			{
				if(is_numeric($id))
				{
					$_SESSION['modify_users']['folder'][$id] = $name;
				}
			}
			$new = 1;
		}
	}
}
else
	print_back('manage_questionnaire_users');

if(isset($_POST['rename']))
{
	$empty = 0;
	foreach($_SESSION['modify_users']['file'] AS $id => $name)
	{
		if($name['name'] == "")
			$empty = 1;
	}
	foreach($_SESSION['modify_users']['folder'] AS $id => $name)
	{
		if($name['name'] == "")
			$empty = 1;
	}

	if($empty)
		$status[] = array('type' => 'error', 'text' => 'All groups and users has to have a name.');
	else
	{
		if(count($_SESSION['modify_users']['file']) > 0)
		{
			$emailempty = 0;
			$emailexists = 0;
			foreach($_SESSION['modify_users']['file'] AS $id => $name)
			{
				$email = clean_string($name['email']);
				$sql = "SELECT id FROM users WHERE email='$email'";
				$result = my_query($sql, $mysql_handler);
				$data = mysql_fetch_row($result);
				if(isset($data[0]) && $id != $data[0])
					$emailexists = $id;
				if(empty($name['email']))
					$emailempty = 1;
			}

			if(!$emailexists && !$emailempty)
			{
				foreach($_SESSION['modify_users']['file'] AS $id => $name)
				{
					$email = clean_string($name['email']);
					if(!empty($name['password']))
						$password = ", password='".md5($name['password'])."'";
					else
						$password = "";
					if(isset($_SESSION['superuser']))
						$aname = "name='".clean_string($name['name'])."',";
					else
						$aname = "";

					if(is_numeric($id))
					{
							$sql = "UPDATE users SET $aname email='$email'$password WHERE id = $id";
							my_query($sql, $mysql_handler);
					}
				}
			}
		}
		if(!$emailexists && !$emailempty)
		{
			if(count($_SESSION['modify_users']['folder']) > 0)
			{
					foreach($_SESSION['modify_users']['folder'] AS $id => $name)
					{
						if(is_numeric($id))
						{
							$sql = "UPDATE folders_users SET name='".clean_string($name)."' WHERE id = $id";
							my_query($sql, $mysql_handler);
						}
					}

			}
			print_back('manage_questionnaire_users');
		}
		elseif($emailexists)
			$status[] = array('type' => 'error', 'text' => "E-mail already exists in database!");
		elseif($emailempty)
			$status[] = array('type' => 'error', 'text' => "All users has to have a valid email!");
	}
}
elseif(isset($_POST['cancel']))
{
	//cancel
	print_back('manage_questionnaire_users');
}

if($new)
{
	foreach($_SESSION['modify_users']['file'] AS $id => $name)
	{
		$files_are = 1;
	}
	foreach($_SESSION['modify_users']['folder'] AS $id => $name)
	{
		$folders_are = 1;
	}
}
else
{
	foreach($_SESSION['modify_users']['file'] AS $id)
	{
		$files_are = 1;
	}
	foreach($_SESSION['modify_users']['folder'] AS $id)
	{
		$folders_are = 1;
	}
}

$pagetitle = 'Rename';

if(!error_to_report($status))
{
	if($files_are && $folders_are)
		$status[] = array('type' => 'description', 'text' => 'Enter the new names of the users and groups.');
	elseif($folders_are)
		$status[] = array('type' => 'description', 'text' => 'Enter the new names of the groups.');
	elseif($files_are)
		$status[] = array('type' => 'description', 'text' => 'Enter the new names of the users.');
}
pageHeader($pagetitle, $path, $path_back, $status);

?>
<form name="rename_filetree" action="index.php" method="post">
<input type="hidden" name="page" value="change_user" />
<table>
<?php

if($new)
{
	if(count($_SESSION['modify_users']['file']) > 0)
	{
		echo "<tr><td><b>Users</b><br /></tr></td>";
		foreach($_SESSION['modify_users']['file'] AS $id => $name)
		{
			?>
			<tr>
				<td>Name</td><td><input <?php if(!$_SESSION['superuser']) echo "readonly=\"readonly\""; ?> type="text" name="filename[<?php echo $id; ?>]" value="<?php echo get_print_value($name['name']); ?>" /></td>
			</tr>
			<tr>
				<td>E-mail</td><td><input type="text" name="fileemail[<?php echo $id; ?>]" value="<?php echo get_print_value($name['email']); ?>" /><?php if($emailexists && $emailexists == $id) echo "<img src=\"img/zeus_error_tiny.png\" />"; ?></td>
			</tr>
			<tr>
				<td>Password</td><td valign="top"><input type="text" name="filepassword[<?php echo $id; ?>]" value="<?php echo get_print_value($name['password']); ?>" /></td>
			</tr>
			<tr><td>&nbsp;</td></tr>
			<?php
		}
	}
	if(count($_SESSION['modify_users']['folder']) > 0)
	{
		echo "<tr><td><b>Groups</b><br /></tr></td>";
		foreach($_SESSION['modify_users']['folder'] AS $id => $name)
		{
			if(is_numeric($id))
			{
				$sql = "SELECT name FROM folders_users WHERE id = $id";
		
				$result = my_query($sql, $mysql_handler);
				$data = mysql_fetch_assoc($result);
		
				?>
				<tr>
					<td colspan="2"><input type="text" name="folder[<?php echo $id; ?>]" value="<?php echo get_print_value($name); ?>" /></td>
				</tr>
				<tr><td>&nbsp;</td></tr>
				<?php
			}
		}
	}
}
else
{
	if(count($_SESSION['modify_users']['file']) > 0)
	{
		echo "<tr><td><b>Users</b><br /></tr></td>";
		foreach($_SESSION['modify_users']['file'] AS $id)
		{
			if(is_numeric($id))
			{
				$sql = "SELECT name, email, password FROM users WHERE id = $id";
	
				$result = my_query($sql, $mysql_handler);
				$data = mysql_fetch_assoc($result);
	
				?>
				<tr>
					<td>Name</td><td><input <?php if(!$_SESSION['superuser']) echo "readonly=\"readonly\""; ?> type="text" name="filename[<?php echo $id; ?>]" value="<?php echo get_print_value($data['name']); ?>" /></td>
				</tr>
				<tr>
					<td>E-mail</td><td><input type="text" name="fileemail[<?php echo $id; ?>]" value="<?php echo get_print_value($data['email']); ?>" /></td>
				</tr>
				<tr>
					<td>Password</td><td><input type="text" name="filepassword[<?php echo $id; ?>]" value="" /></td>
				</tr>
				<tr><td>&nbsp;</td></tr>
				<?php
			}
		}
	}
	if(count($_SESSION['modify_users']['folder']) > 0)
	{
		echo "<tr><td><b>Groups</b><br /></tr></td>";
		foreach($_SESSION['modify_users']['folder'] AS $id)
		{
			if(is_numeric($id))
			{
				$sql = "SELECT name FROM folders_users WHERE id = $id";
		
				$result = my_query($sql, $mysql_handler);
				$data = mysql_fetch_assoc($result);
		
				?>
				<tr>
					<td colspan="2"><input type="text" name="folder[<?php echo $id; ?>]" value="<?php echo get_print_value($data['name']); ?>" /></td>
				</tr>
				<tr><td>&nbsp;</td></tr>
				<?php
			}
		}
	}
}

?>
	<tr>
		<td colspan="2" align="right"><br /><input type="submit" name="rename" class="button_green button_normal" value="Change" />&nbsp;<input type="submit" class="button_red button_normal" name="cancel" value="Cancel" /></td>
	</tr>
</table>
</form>
<?php

pageFooter();
?>