<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: function_generate_questionnaire.inc.php,v 1.18 2006/06/07 07:58:57 medea2 Exp $
*/

function generate_questionnaire($questionnaire_id, $type = 'preview', $mysql_handler, $answer_id = -1, $first_last = array())
{
	//Check if type is valid
	$valid_types = array('preview', 'show_ind');
	if(!in_array($type, $valid_types))
	{
		foreach($valid_types as $valid_type)
		{
			$echo_str .= $valid_type.', ';
		}
		$echo_str = substr($echo_str, 0, strlen($echo_str)-strlen(', '));
		echo 'generate_questionnaire(): Invalid argument type, valid types are: '.$echo_str;
		die();
	}

	//Print questionnaire name and description
	$sql = "SELECT name, description FROM questionnaires WHERE id = " . $questionnaire_id;
	$result = my_query($sql, $mysql_handler);
	$selected_sql = mysql_fetch_assoc($result);
	
	$path = get_absolute_path_string($questionnaire_id, $mysql_handler, ', ') . $selected_sql['name'];
	
	// Fetch rowcolors
	$sql = "SELECT question_row_color1, question_row_color2 FROM site_properties WHERE id = 1";
	$result = my_query($sql, $mysql_handler);
	$row_colors = mysql_fetch_row($result);
	$row_color1 = $row_colors[0];
	$row_color2 = $row_colors[1];
	
	if($type == 'preview')
	{
		echo "<h2>Preview of $path</h2>";
		print_status('description', $selected_sql['description']);
	}
	elseif($type == 'show_ind')
	{
		$disable = true;

		$page_size = $_SESSION['page_size'];
		
		if ($page_size == 'large')
		{
			$large = "_large";
		}
		else
		{
			$large = "";
		}

?>
		<table width="100%">
			<tr>
				<td>
					<?php echo "<h2>Individual answers from $path (Answer ID #$answer_id)</h2>";?>
				</td>
				<td align="right">
					<a href="<?php print_href('export_individual_answers', array('answer' => $answer_id)); ?>"><img src="img/zeus_export_all_ind_ans<?php echo $large;?>.png" alt="Export all answers" style="border: 1px solid black" /></a>
				</td>
			</tr>
		</table>
<?php
		
		print_status('description', "All the sets of answers to the questionnaire are shown in the order they were received. Click on the buttons below to go back and forth between sets.");
	}
	
	$sql = "SELECT id, name, questiontype, number_of_rows, several FROM questions WHERE questionnaire_id = $questionnaire_id ORDER BY sort_order";
	$result = my_query($sql, $mysql_handler);
	
	if( $type == 'preview')
		$answer_data = array();
	if( $type == 'show_ind' )
	{
		$sql = "SELECT question_id, response FROM questionnaires_data WHERE answer_id = $answer_id";
		$result2 = my_query($sql, $mysql_handler);
		
		$answer_data = array();
		while( $row = mysql_fetch_assoc($result2))
		{
			$question_id = $row['question_id'];
			$response = $row['response'];
			
			$answer_data[$answer_id][$question_id][] = $response;
		}
	}
	
	$rowcolor = $row_color2;
	
	for(;$questions = mysql_fetch_assoc($result); $lastquestiontype = $questions['questiontype'])
	{
		// Alternate row color
		if ($rowcolor == $row_color2)
			$rowcolor = $row_color1;
		else
			$rowcolor = $row_color2;
	
		if($lastquestiontype != $questions['questiontype'] || $questions['questiontype'] == 'textquestion')
		{
			echo '<br />';
		}
		switch($questions['questiontype'])
		{
			case 'gradedquestion':
			{
				if($lastquestiontype != $questions['questiontype'])
					print_graded_question( $questions['id'], $questions['name'], $answer_data[$answer_id][$questions['id']][0], 1, $disable, $rowcolor);
				else
					print_graded_question( $questions['id'], $questions['name'], $answer_data[$answer_id][$questions['id']][0], 0, $disable, $rowcolor);
			}break;
			case 'textquestion':
			{
				print_text_question( $questions['id'], $questions['name'], $questions['number_of_rows'], $answer_data[$answer_id][$questions['id']][0], $disable);
			}break;
			case 'multiple_choice':
			{
				print_multiple_choice($questions['id'], $questions['name'], $questions['several'], $answer_data[$answer_id][$questions['id']], $mysql_handler, $disable, $row_color1, $row_color2);
			
			}break;
			case 'number':
			{
				print_number($questions['id'], $questions['name'], $answer_data[$answer_id][$questions['id']][0], $disable);
			
			}break;
		}
	}
	echo '<br />';
	if ($type == 'show_ind')
	{
?>
	<form name="browse_answers_down" action="index.php" method="post">
		<input type="hidden" name="page" value="show_individual_answers" />
		<input type="hidden" name="answer" value="<?php echo $answer_id?>" />
		<input type="submit" name="prev" class="button_blue button_nearwide"  <?php if($answer_id == $first_last[0]){echo 'disabled="disabled"'; }?> value="&lt;&lt; Previous" />
		<input type="submit" name="next" class="button_blue  button_nearwide"  <?php if($answer_id == $first_last[1]){echo 'disabled="disabled"'; }?> value="Next &gt;&gt;" />
	</form>
<?php
	}

}
function print_graded_question( $id, $txt, $ans = '', $headline = 0, $disabled = false, $rowcolor)
{
	if($headline != 0)
	{
?>
		<table cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="question_td">&nbsp;</td>
				<td class="question_fullyd" align="left"><b>Fully<br />disagree</b></td>
				<td class="question_fullya" align="left"><b>Fully<br />agree</b></td>
			</tr>
		</table>
<?php
	}

	$page_size = $_SESSION['page_size'];
	
	if ($page_size == 'large')
	{
		$checked_radio = 'img/zeus_radiobutton_checked_large.gif';
		$checked_box = 'img/zeus_checkbox_checked_large.gif';
		
		$unchecked_radio = 'img/zeus_radiobutton_unchecked_large.gif';
		$unchecked_box = 'img/zeus_checkbox_unchecked_large.gif';
		$large = "_large";
	}
	else
	{
		$checked_radio = 'img/zeus_radiobutton_checked.gif';
		$checked_box = 'img/zeus_checkbox_checked.gif';
		
		$unchecked_radio = 'img/zeus_radiobutton_unchecked.gif';
		$unchecked_box = 'img/zeus_checkbox_unchecked.gif';
		$large = "";
	}


?>
	<table cellspacing="0" cellpadding="0" border="0">
		<tr bgcolor="<?php echo $rowcolor;?>">
			<td class="question_td">
				<img src="img/zeus_question<?php echo $large; ?>.gif" style="vertical-align: middle;" alt="question" />&nbsp;<?php echo get_print_value($txt); ?>
			</td>
			<td class="question_radio_td">
<?php				
				if ($disabled)
				{
					if ($ans == '-100')
						echo "<img alt=\"checked\" src=\"$checked_radio\" />";
					else
						echo "<img alt=\"unchecked\" src=\"$unchecked_radio\" />";
				}
				else
					echo "<input type=\"radio\" class=\"radio\" name=\"reply[$id]\" value=\"-100\" />";
?>
			</td>
			<td class="question_radio_td">
<?php				
				if ($disabled)
				{
					if ($ans == '-50')
						echo "<img alt=\"checked\" src=\"$checked_radio\" />";
					else
						echo "<img alt=\"unchecked\" src=\"$unchecked_radio\" />";
				}
				else
					echo "<input type=\"radio\" class=\"radio\" name=\"reply[$id]\" value=\"-50\" />";
?>			
			</td>
			<td class="question_radio_td">
<?php				
				if ($disabled)
				{
					if ($ans == '0')
						echo "<img alt=\"checked\" src=\"$checked_radio\" />";
					else
						echo "<img alt=\"unchecked\" src=\"$unchecked_radio\" />";
				}
				else
					echo "<input type=\"radio\" class=\"radio\" name=\"reply[$id]\" value=\"0\" />";
?>				
			</td>
			<td class="question_radio_td">
<?php				
				if ($disabled)
				{
					if ($ans == '50')
						echo "<img alt=\"checked\" src=\"$checked_radio\" />";
					else
						echo "<img alt=\"unchecked\" src=\"$unchecked_radio\" />";
				}
				else
					echo "<input type=\"radio\" class=\"radio\" name=\"reply[$id]\" value=\"50\" />";
?>				
			</td>
			<td class="question_radio_td">
<?php				
				if ($disabled)
				{
					if ($ans == '100')
						echo "<img alt=\"checked\" src=\"$checked_radio\" />";
					else
						echo "<img alt=\"unchecked\" src=\"$unchecked_radio\" />";
				}
				else
					echo "<input type=\"radio\" class=\"radio\" name=\"reply[$id]\" value=\"100\" />";
?>
			</td>
		</tr>
	</table>
<?php
}
function print_text_question($id, $txt, $num_rows, $ans = '', $disabled=false)
{

	$page_size = $_SESSION['page_size'];
	
	if ($page_size == 'large')
	{
		$large = "_large";
	}
	else
	{
		$large = "";
	}

?>
	<table cellspacing="0" cellpadding="0" border="0">
	<tr>
		<td class="question_td"><img src="img/zeus_question<?php echo $large; ?>.gif" style="vertical-align: middle;" alt="question" />&nbsp;<b><?php echo get_print_value($txt); ?></b></td>
	</tr>
	<tr>
		<td class="question_text">
		<textarea style="height: <?php echo $num_rows; ?>em;" name="reply[<?php echo $id; ?>]" rows"<?php echo $num_rows; ?>" cols="5" style="background-color:<?php echo $color2; ?>;" class="question_text" <?php if($disabled) echo 'readonly="readonly" '; ?>><?php if(!empty($ans)) echo get_print_value($ans); ?></textarea>
		</td>
	</tr>
				
	</table>
<?php
}
?>
<?php
function print_multiple_choice($id, $txt, $several, $ans, $mysql_handler, $disabled=false, $rowcolor1, $rowcolor2)
{
	$altsql = "SELECT alternative, id FROM question_alternatives WHERE question_id = $id ORDER BY sort_order";
	$altresult = my_query($altsql, $mysql_handler);	

	$page_size = $_SESSION['page_size'];
	
	if ($page_size == 'large')
	{
		$checked['radio'] = 'img/zeus_radiobutton_checked_large.gif';
		$checked['checkbox'] = 'img/zeus_checkbox_checked_large.gif';

		$unchecked['radio'] = 'img/zeus_radiobutton_unchecked_large.gif';
		$unchecked['checkbox'] = 'img/zeus_checkbox_unchecked_large.gif';

		$large = "_large";
	}
	else
	{
		$checked['radio'] = 'img/zeus_radiobutton_checked.gif';
		$checked['checkbox'] = 'img/zeus_checkbox_checked.gif';

		$unchecked['radio'] = 'img/zeus_radiobutton_unchecked.gif';
		$unchecked['checkbox'] = 'img/zeus_checkbox_unchecked.gif';

		$large = "";
	}
?>
	<table cellspacing="0" cellpadding="0" border="0">
		<tr>
			<td class="question_text"><img src="img/zeus_question<?php echo $large; ?>.gif" style="vertical-align: middle;" alt="question" />&nbsp;<b><?php echo get_print_value($txt); ?></b></td>
		</tr>
	</table>
<?php
	for($j = 0; $alternative = mysql_fetch_assoc($altresult); $j++)
	{
		$alt_id = $alternative['id'];
		
		if($j % 2 == 0)
			$rowcolor = $rowcolor1;
		else
			$rowcolor = $rowcolor2;
	
		if($several)
			$inputtype = 'checkbox';
		else
			$inputtype = 'radio';
?>
	<table cellspacing="0" cellpadding="0" border="0">
		<tr bgcolor="<?php echo $rowcolor; ?>">
			<td class="question_several">
				<?php echo '&nbsp;&nbsp;&nbsp;&nbsp;'.get_print_value($alternative['alternative']); ?>
			</td>
			
			<td align="left" class="question_radio_td">
<?php
				if ($disabled)
				{
					if (is_array($ans) && in_array($alternative['alternative'], $ans))
						echo "<img alt=\"checked\" src=\"".$checked[$inputtype]."\" />";
					else
						echo "<img alt=\"unchecked\" src=\"".$unchecked[$inputtype]."\" />";
				}
				else
					echo "<input type=\"$inputtype\" class=\"$inputtype\" name=\"reply[$id][]\" value=\"$alt_id\" />";
?>
			</td>
			<td class="question_fullya">
				&nbsp;
			</td>
		</tr>
	</table>

<?php
	}
}
?>
<?php
function print_number($id, $txt, $ans = '', $disabled=false)
{

	$page_size = $_SESSION['page_size'];
	if ($page_size == 'large')
	{

		$large = "_large";
	}
	else
	{

		$large = "";
	}

?>
	<table cellspacing="0" cellpadding="0" border="0" width="750">
		<tr>
			<td class="question_td"><b><img src="img/zeus_question<?php echo $large; ?>.gif" style="vertical-align: middle;" alt="question" />&nbsp;<?php echo get_print_value($txt); ?></b>
			</td>
		</tr>
		<tr>
			<td>
				<table width="100%" cellspacing="0" cellpadding="0" border="0">
					<tr>
						<td class="question_number">
							<input type="text" name="reply[<?php echo $id; ?>]" style="background-color:<?php echo $color2; ?>;" class="question_number" value="<?php echo get_print_value($ans); ?>" <?php if($disabled) echo 'readonly="readonly" '; ?>/>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
<?php
}
?>
