<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: function_print_filetree.inc.php,v 1.32 2006/06/07 09:50:51 medea1 Exp $

*/


// Wrapper for print_filetree(..) so its enclosed in a table.
function print_full_filetree($parent_folder, $open_folders, $page, $mysql_handler, $level = 0, $show_files = 1, $type = "checkbox", $selected_folder = 0, $selected_file = 0, $print_root = 1, $usertree = 0, $selectfolders = 1, $user_id = -1, $selected_files = array(), $disabled_files = array(), $page_size = "normal", $no_file_link = 0)
{
	echo "<div class=\"filebrowser\"><table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n";
	if($parent_folder == 0 && $print_root == 1)
	{

		if($usertree)
		{
			if($page_size == "large")
				$img = "zeus_group_large.gif";
			else
				$img = "zeus_group.gif";
		}
		else
		{
			if(folder_empty(0, $usertree, $mysql_handler))
			{
				if($page_size == "large")
					$img = "zeus_folder_owned_open_large.gif";
				else
					$img = "zeus_folder_owned_open.gif";
			}
			else
			{
				if($page_size == "large")
					$img = "zeus_folder_owned_content_large.gif";
				else
					$img = "zeus_folder_owned_content.gif";
			}
		}

		if($selectfolders)
			echo "<tr id=\"folder0\" onmouseover=\"highlight('folder0', 1, 'folder0box');\" onmouseout=\"highlight('folder0', 0, 'folder0box');\">\n\t<td width=\"10\">";
		else
			echo "<tr id=\"folder0\" \">\n\t<td width=\"10\">";

		if($selectfolders)
			echo "<input onclick=\"mark_box('folder0');\" id=\"folder0box\" class=\"$type\" type=\"$type\" name=\"list[]\" value=\"folder0\" />";

		echo "</td>\n\t";
		echo "<td";

		if($selectfolders)
			echo " onclick=\"mark('folder0box', 'folder0');\"";

		echo ">\n\t\t<table>\n\t\t\t<tr>\n\t\t\t\t<td style=\"width: 0px;\"><img src=\"img/$img\" alt=\"open folder\" align=\"right\" /> </td>\n\t<td class=\"folder_name\">/</td>\n\t\t\t</tr>\n\t\t</table>\n\t</td>\n</tr>\n";

	}
	print_filetree($parent_folder, $open_folders, $page, $mysql_handler, $level+1, $show_files, $type, $selected_folder, $selected_file, $usertree, $selectfolders, $user_id, $selected_files, $disabled_files, $page_size, $no_file_link);
	echo "</table></div>\n";

}


function print_filetree($parent_folder, $open_folders, $page, $mysql_handler, $level = 0, $show_files = 1, $type = "checkbox", $selected_folder = 0, $selected_file = 0, $usertree = 0, $selectfolders = 1, $user_id = -1, $selected_files = array(), $disabled_files = array(), $page_size = "normal", $no_file_link)
{
	if(is_numeric($parent_folder))
	{
		if($usertree)
			$sql = "SELECT name, id, owner FROM folders_users WHERE parent_folder = $parent_folder ORDER BY name";
		else
			$sql = "SELECT name, id, owner FROM folders_questionnaires WHERE parent_folder = $parent_folder ORDER BY name";
		$result = my_query($sql, $mysql_handler);
	
		while($folder = mysql_fetch_assoc($result))
		{
			$rowid = "folder".$folder['id'];
			$boxid = "folder".$folder['id']."box";
		
			if($selectfolders)
			{
				echo "<tr id=\"$rowid\" onmouseover=\"highlight('$rowid', 1, '$boxid');\" onmouseout=\"highlight('$rowid', 0, '$boxid');\">\n\t<td width=\"10\">";

				if($folder['id'] == $selected_folder)
				{
					echo "<input onclick=\"mark_box('$rowid');\" id=\"$boxid\" class=\"$type\" type=\"$type\" name=\"list[]\" value=\"folder".$folder['id']."\" checked=\"checked\" />\n";
					echo "<script language=\"javascript\" type=\"text/javascript\">\n";
					echo "mark_box('$rowid');\n";
					echo "</script>\n";
				}
				else
					echo "<input onclick=\"mark_box('$rowid');\" id=\"$boxid\" class=\"$type\" type=\"$type\" name=\"list[]\" value=\"folder".$folder['id']."\" />";
			}
			else
				echo "<tr id=\"$rowid\">\n\t<td width=\"10\">&nbsp;";
	
			echo "</td>\n\t";
	
			if($open_folders[$folder['id']])
			{
				if($usertree)
				{
					if($page_size == 'large')
					{
						$img = "zeus_group_large.gif";
					}
					else
					{
						$img = "zeus_group.gif";
					}
				}
				else
				{
					if(folder_empty($folder['id'], $usertree, $mysql_handler))
					{
						if($page_size == 'large')
						{
							if($user_id == $folder['owner'])
								$img = "zeus_folder_owned_open_large.gif";
							else
								$img = "zeus_folder_open_large.gif";
						}
						else
						{
							if($user_id == $folder['owner'])
								$img = "zeus_folder_owned_open.gif";
							else
								$img = "zeus_folder_open.gif";
						}
					}
					else
					{
						if($page_size == 'large')
						{
							if($user_id == $folder['owner'])
								$img = "zeus_folder_owned_content_large.gif";
							else
								$img = "zeus_folder_content_large.gif";
						}
						else
						{
							if($user_id == $folder['owner'])
								$img = "zeus_folder_owned_content.gif";
							else
								$img = "zeus_folder_content.gif";
						}
					}
				}
	
				$name = substr($folder['name'], 0, 18);

				if(strlen($folder['name']) > 18)
					$name .= " ..";

				if($selectfolders)
					echo "<td onclick=\"mark('$boxid', '$rowid');\">\n\t\t<table>\n\t\t\t<tr>\n\t\t\t\t<td style=\"width: ".($level * 20 + 20)."px;\"><a href=\"index.php?page=".$page."&amp;folder=".$folder['id']."\"><img src=\"img/$img\" alt=\"open folder\" align=\"right\" /></a> </td>\n\t<td class=\"folder_name\"><a href=\"index.php?page=".$page."&amp;folder=".$folder['id']."\">$name</a></td>\n\t\t\t</tr>\n\t\t</table>\n\t</td>\n</tr>\n";
				else
					echo "<td>\n\t\t<table>\n\t\t\t<tr>\n\t\t\t\t<td style=\"width: ".($level * 20 + 20)."px;\"><a href=\"index.php?page=".$page."&amp;folder=".$folder['id']."\"><img src=\"img/$img\" alt=\"open folder\" align=\"right\" /></a> </td>\n\t<td class=\"folder_name\"><a href=\"index.php?page=".$page."&amp;folder=".$folder['id']."\">$name</a></td>\n\t\t\t</tr>\n\t\t</table>\n\t</td>\n</tr>\n";
				
				print_filetree($folder['id'], $open_folders, $page, $mysql_handler, ($level + 1), $show_files, $type, $selected_folder, $selected_file, $usertree,  $selectfolders, $user_id, $selected_files, $disabled_files, $page_size, $no_file_link);
			}
			else
			{
				if($usertree)
				{
					if($page_size == 'large')
						$img = "zeus_group_large.gif";
					else
						$img = "zeus_group.gif";
				}
				else
				{
					if($page_size == 'large')
					{
						if($user_id == $folder['owner'])
							$img = "zeus_folder_owned_large.gif";
						else
							$img = "zeus_folder_closed_large.gif";
					}
					else
					{
						if($user_id == $folder['owner'])
							$img = "zeus_folder_owned.gif";
						else
							$img = "zeus_folder_closed.gif";
					}
				}

				$name = substr($folder['name'], 0, 18);

				if(strlen($folder['name']) > 18)
					$name .= " ..";


				if($selectfolders)
					echo "<td onclick=\"mark('$boxid', '$rowid');\">\n\t\t<table>\n\t\t\t<tr>\n\t\t\t\t<td style=\"width: ".($level * 20 + 20)."px;\"><a href=\"index.php?page=".$page."&amp;folder=".$folder['id']."\"><img src=\"img/$img\" alt=\"closed folder\" align=\"right\" /></a> </td>\n\t<td class=\"folder_name\"><a href=\"index.php?page=".$page."&amp;folder=".$folder['id']."\">$name</a></td>\n\t\t\t</tr>\n\t\t</table>\n\t</td>\n</tr>\n";
				else
					echo "<td>\n\t\t<table>\n\t\t\t<tr>\n\t\t\t\t<td style=\"width: ".($level * 20 + 20)."px;\"><a href=\"index.php?page=".$page."&amp;folder=".$folder['id']."\"><img src=\"img/$img\" alt=\"closed folder\" align=\"right\" /></a> </td>\n\t<td class=\"folder_name\"><a href=\"index.php?page=".$page."&amp;folder=".$folder['id']."\">$name</a></td>\n\t\t\t</tr>\n\t\t</table>\n\t</td>\n</tr>\n";

			}
		}
	
		if($show_files)
		{
			if($usertree)
				$sql = "SELECT name, id, email FROM users WHERE folder_id = $parent_folder ORDER BY name";
			else
				$sql = "SELECT name, id, published FROM questionnaires WHERE folder_id = $parent_folder ORDER BY name";
			$result = my_query($sql, $mysql_handler);
		
			while($file = mysql_fetch_assoc($result))
			{
				$rowid = "file".$file['id'];
				$boxid = "file".$file['id']."box";

	
				echo "<tr id=\"$rowid\"  onmouseover=\"highlight('$rowid', 1, '$boxid');\" onmouseout=\"highlight('$rowid', 0, '$boxid');\">\n\t<td width=\"10\">";

				echo "<input onclick=\"mark_box('$rowid');\" id=\"$boxid\" class=\"$type\" type=\"$type\" name=\"list[]\" value=\"file".$file['id']."\"";

				if($selected_file == $file['id'])
					echo " checked=\"checked\"";

				echo " /></td>\n\t<td onclick=\"mark('$boxid', '$rowid');\">\n\t\t<table>\n\t\t\t<tr>\n\t\t\t\t<td style=\"width: ".($level * 20 + 20)."px;\">";
	
				if($selected_file == $file['id'])
				{
					echo "<script language=\"javascript\" type=\"text/javascript\">\n";
					echo "mark_box('$rowid');\n";
					echo "</script>\n";
				}
	
				if(!$usertree)
				{
					if($page_size == 'large')
					{
						if($file['published'])
							$img = "zeus_document_published_large.gif";
						else
							$img = "zeus_document_unpublished_large.gif";
					}
					else
					{
						if($file['published'])
							$img = "zeus_document_published.gif";
						else
							$img = "zeus_document_unpublished.gif";

					}
				
					if($no_file_link)
						echo "<img src=\"img/$img\" alt=\"file\" align=\"right\" /></td>\n\t<td class=\"file_name\">".$file['name']."</td>\n\t\t\t</tr>\n\t\t</table>\n\t</td>\n</tr>\n";
					else
						echo "<a href=\"index.php?page=".$page."&amp;file=".$file['id']."\"><img src=\"img/$img\" alt=\"file\" align=\"right\" /></a></td>\n\t<td class=\"file_name\"><a href=\"index.php?page=".$page."&amp;file=".$file['id']."\">".$file['name']."</a></td>\n\t\t\t</tr>\n\t\t</table>\n\t</td>\n</tr>\n";
				}
				else
				{
					if($page_size == 'large')
					{
						$img = 'zeus_user_large.gif';
						if(isset($selected_files[$file['id']]))
							$img = 'zeus_user_in_quest_large.gif';
						if(isset($disabled_files[$file['id']]))
							$img = 'zeus_user_in_quest_large.gif';
					}
					else
					{
						$img = 'zeus_user.gif';
						if(isset($selected_files[$file['id']]))
							$img = 'zeus_user_in_quest.gif';
						if(isset($disabled_files[$file['id']]))
							$img = 'zeus_user_in_quest.gif';
					}

					if($no_file_link)
						echo "<img src=\"img/$img\" alt=\"file\" align=\"right\" /></td>\n\t<td class=\"file_name\">".$file['name']." - ".$file['email']."</td>\n\t\t\t</tr>\n\t\t</table>\n\t</td>\n</tr>\n";
					else
						echo "<a href=\"index.php?page=".$page."&amp;file=".$file['id']."\"><img src=\"img/$img\" alt=\"file\" align=\"right\" /></a></td>\n\t<td class=\"file_name\"><a href=\"index.php?page=".$page."&amp;file=".$file['id']."\">".$file['name']." - ".$file['email']."</a></td>\n\t\t\t</tr>\n\t\t</table>\n\t</td>\n</tr>\n";
				}
			}
		}
	}
}

function folder_empty($folder_id, $usertree, $mysql_handler)
{
	if(is_numeric($folder_id))
	{
		$empty = true;
	
		if($usertree)
		{
			$folder_table = "folders_users";
			$file_table = "users";
		}
		else
		{
			$folder_table = "folders_questionnaires";
			$file_table = "questionnaires";
		}
	
		$sql = "SELECT id FROM $folder_table WHERE parent_folder = $folder_id";
		$result = my_query($sql, $mysql_handler);
		$data = mysql_fetch_row($result);
			
		// id is always > 0 thus true if set. 
		if($data[0])
			$empty = false;
		
		if($empty)
		{
			$sql = "SELECT id FROM $file_table WHERE folder_id = $folder_id";
			$result = my_query($sql, $mysql_handler);
			$data = mysql_fetch_row($result);
	
			// id is always > 0 thus true if set. 
			if($data[0])
				$empty = false;
		}
			
		return $empty;
	}
	else
		return false;
}

function get_parent_folders($folder_id, $mysql_handler, $usertree = 0, $levels = -1)
{
	if(is_numeric($folder_id))
	{
		if($levels != 0)
		{
			if($levels > 0)
				$levels--;

			if ($folder_id == 0)
				return array();
			
			if($usertree)
				$sql = "SELECT parent_folder, name FROM folders_users WHERE id = $folder_id";
			else
				$sql = "SELECT parent_folder, name FROM folders_questionnaires WHERE id = $folder_id";
		
			$result = my_query($sql, $mysql_handler);
			list($parent_id, $name) = mysql_fetch_row($result);
			
			$return_array = get_parent_folders($parent_id, $mysql_handler, $usertree, $levels);
			$return_array[] = array('id' => $folder_id, 'name' => $name);
			
			return $return_array;
		}
		else
			return array();
	}
	else
		return false;
}

function get_parent_folders_string($folder_id, $mysql_handler, $d = "/", $usertree = 0, $levels = -1)
{
	$arr = array();

	$arr = get_parent_folders($folder_id, $mysql_handler, $usertree, $levels);
	
	//$arr = array_reverse($arr);
	
	foreach($arr AS $folder)
	{
		$string .= $folder['name'].$d;
	}

	return $string;
}

function get_absolute_path_string($file_id, $mysql_handler, $d = "/", $users = 0, $levels = -1)
{
	if(is_numeric($file_id))
	{
		$path = array();
		
		//Get parent folder
		if($users)
			$sql = "SELECT folder_id FROM users WHERE id = $file_id";
		else
			$sql = "SELECT folder_id FROM questionnaires WHERE id = $file_id";
		$result = my_query($sql, $mysql_handler);
		$folder_id = mysql_result($result,0);
		
		return get_parent_folders_string($folder_id, $mysql_handler, $d, $users, $levels);
	}
	else
		return false;
}

function is_in_tree($parent_folder, $folder_id, $mysql_handler, $users = 0)
{
	if(is_numeric($parent_folder))
	{
		if($parent_folder == $folder_id)
			return true;

		if($users)
			$sql = "SELECT id FROM folders_users WHERE parent_folder = $parent_folder";
		else
			$sql = "SELECT id FROM folders_questionnaires WHERE parent_folder = $parent_folder";
		$result = my_query($sql, $mysql_handler);
	
		while($folder = mysql_fetch_assoc($result))
		{
			if($folder['id'] == $folder_id)
				return true;
			else
				return is_in_tree($folder['id'], $folder_id, $mysql_handler, $users);
		}
	

	}
	else
		return false;
}

function add_folder_with_users_to_questionnaire($q_id, $f_id, $mysql_handler)
{
	if(is_numeric($q_id) && is_numeric($f_id))
	{
		$sql = "SELECT id FROM folders_users WHERE parent_folder = $f_id";
		$result = my_query($sql, $mysql_handler);
		while($folders = mysql_fetch_assoc($result))
		{
			add_folder_with_users_to_questionnaire($q_id, $folders['id'], $mysql_handler);
		}
	
		$sql = "SELECT id FROM users WHERE folder_id = $f_id";
		$result = my_query($sql, $mysql_handler);
		while($files = mysql_fetch_assoc($result))
		{
			$sql = "SELECT user_id FROM questionnaires_users WHERE questionnaire_id = $q_id AND user_id = ".$files['id'];
			$inresult = my_query($sql, $mysql_handler);
			$data = mysql_fetch_row($inresult);
			if(!isset($data[0]))
			{
				$sql = "INSERT INTO questionnaires_users (questionnaire_id, user_id) VALUES('$q_id', '".$files['id']."')";
				my_query($sql, $mysql_handler);
			}
		}
	}
}

function remove_folder_with_users_from_questionnaire($q_id, $f_id, $mysql_handler)
{
	if(is_numeric($q_id) && is_numeric($f_id))
	{
		$sql = "SELECT id FROM folders_users WHERE parent_folder = $f_id";
		$result = my_query($sql, $mysql_handler);
		while($folders = mysql_fetch_assoc($result))
		{
			remove_folder_with_users_from_questionnaire($q_id, $folders['id'], $mysql_handler);
		}
	
		$sql = "SELECT id FROM users WHERE folder_id = $f_id";
		$result = my_query($sql, $mysql_handler);
		while($files = mysql_fetch_assoc($result))
		{
			$sql = "DELETE FROM questionnaires_users WHERE questionnaire_id = $q_id AND user_id = ".$files['id'];
			my_query($sql, $mysql_handler);
		}
	}
}


?>
