<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: generate_report.inc.php,v 1.15 2006/06/07 13:00:42 medea7 Exp $
*/

function array_set_pointer(&$array, $value)
{
   reset($array);
   for($i=0;$i<$value;$i++)
   {
       next($array);
   }
}

$questionnaire_id = $_SESSION['active_questionnaire'];

// Get questionnaire info
$sql = "SELECT name, master_question, result_comment_visible FROM questionnaires WHERE id = $questionnaire_id";
$result = my_query($sql, $mysql_handler);
$questionnaire_info = mysql_fetch_row($result);
$master_question_id = $questionnaire_info[1];
$questionnaire_result_comment = $questionnaire_info[2];

// Get questionnaire path
$path = get_absolute_path_string($questionnaire_id, $mysql_handler, ', ');
$questionnaire_name = $questionnaire_info[0];
$questionnaire_info[0] = $path . $questionnaire_info[0];

//Get number of answers
$sql = "SELECT COUNT(*) FROM answers WHERE questionnaire_id = $questionnaire_id";
$result = my_query($sql, $mysql_handler);
$nmb_of_answers = mysql_result($result, 0);

//Get number of total questions in questionnaire
$sql = "SELECT COUNT(*) FROM questions WHERE questionnaire_id = $questionnaire_id";
$result = my_query($sql, $mysql_handler);
$nmb_of_questions = mysql_result($result, 0);

//Get number of total graded questions in questionnaire
$sql = "SELECT COUNT(*) FROM questions WHERE questionnaire_id = $questionnaire_id AND questiontype = 'gradedquestion'";
$result = my_query($sql, $mysql_handler);
$nmb_of_graded_questions = mysql_result($result, 0);

//Get number of total "fully-answer" dependent questions in questionnaire
$sql = "SELECT COUNT(*) FROM questions WHERE questionnaire_id = $questionnaire_id AND (questiontype = 'gradedquestion' OR questiontype = 'multiple_choice' OR questiontype = 'number')";
$result = my_query($sql, $mysql_handler);
$nmb_of_fully_answer_dependent_questions = mysql_result($result, 0);

//Get number of assigned users
$sql = "SELECT COUNT(*) FROM questionnaires_users WHERE questionnaire_id = $questionnaire_id";
$result = my_query($sql, $mysql_handler);
$nmb_of_users = mysql_result($result, 0);

//Get the categories
$sql = "SELECT id, name FROM question_categories WHERE questionnaire_id = $questionnaire_id AND name != 'none'";
$cat_result = my_query($sql, $mysql_handler);
$nmb_of_categories = mysql_num_rows($cat_result);

// Fetch answers where all every graded question is answered
$sql = "SELECT answer_id FROM answers WHERE questionnaire_id = $questionnaire_id";
$result = my_query($sql, $mysql_handler);
while($row = mysql_fetch_row($result))
{
	$answer_id = $row[0];
	// Graded questions
	$sql = "SELECT COUNT(*) FROM questionnaires_data AS qd, questions AS q WHERE qd.answer_id = $answer_id AND qd.question_id = q.id AND (questiontype = 'gradedquestion' OR questiontype = 'multiple_choice' OR questiontype = 'number') GROUP BY qd.answer_id, qd.question_id";
	$result2 = my_query($sql, $mysql_handler);
	if(mysql_num_rows($result2) == $nmb_of_fully_answer_dependent_questions)
		$answ[] = $answer_id;
}
$nmb_of_full_answers = count($answ);

//Get table colors
$sql = "SELECT question_row_color1, question_row_color2 FROM site_properties WHERE id = 1";
$result = my_query($sql, $mysql_handler);
$row_colors = mysql_fetch_row($result);
$row_color1 = $row_colors[0];
$row_color2 = $row_colors[1];

if($nmb_of_answers > 0 && $nmb_of_full_answers > 0)
{
	// Master question
	$sql = "SELECT negate, name FROM questions WHERE id = $master_question_id AND questiontype = 'gradedquestion'";
	$result = my_query($sql, $mysql_handler);
	if(!mysql_num_rows($result))
	{
		$master_question = 0;
	}
	else
	{
		$master_question = mysql_fetch_assoc($result);
		$q_negate = $master_question['negate'];
	
		//summerize score and get average for each answered question
		$answer_score_list = array();
		$masterq_answer_count = array();
		$masterq['satisfied']['answers'] = array();
		$masterq['neutral']['answers'] = array();
		$masterq['unsatisfied']['answers'] = array();
		foreach($answ AS $answer_int_id => $answer_id)
		{
			$query = "SELECT response, answer_id FROM questionnaires_data WHERE question_id = $master_question_id AND answer_id = $answer_id";
			$query_result = my_query($query, $mysql_handler);

			$response = mysql_fetch_row($query_result);
	
			if ($q_negate)
				$response[0] *= -1;
			$answer_score_list[] = $response[0];
			$masterq_answer_count[$response[0]]++;
			if($response[0] < 0)
				$masterq['unsatisfied']['answers'][] = $response[1];
			elseif($response[0] == 0)
				$masterq['neutral']['answers'][] = $response[1];
			else
				$masterq['satisfied']['answers'][] = $response[1];
		}
	
		$masterq_answers = count($answer_score_list);
		$masterq_answer_score = get_average($answer_score_list);
		$masterq_answer_median = get_median($answer_score_list);
		// Get standard deviation
		$masterq_answer_stddeviation = get_stddeviation($answer_score_list);
		
		// Labels
		$masterq['satisfied']['label'] = 'Agree';
		$masterq['neutral']['label'] = 'Neutral';
		$masterq['unsatisfied']['label'] = 'Disagree';
		
		// Explain
		$masterq['satisfied']['explain'] = ' (>0)';
		$masterq['neutral']['explain'] = ' (0)';
		$masterq['unsatisfied']['explain'] = ' (<0)';
		
		$masterq['unsatisfied']['count'] = $masterq_answer_count[-100]+$masterq_answer_count[-50];
		$masterq['unsatisfied']['percent'] = ($masterq['unsatisfied']['count']/$masterq_answers)*100;
		$masterq['neutral']['count'] = 1*$masterq_answer_count[0];
		$masterq['neutral']['percent'] = ($masterq['neutral']['count']/$masterq_answers)*100;
		$masterq['satisfied']['count'] = $masterq_answer_count[100]+$masterq_answer_count[50];
		$masterq['satisfied']['percent'] = ($masterq['satisfied']['count']/$masterq_answers)*100;
	}
	
	// Graded questions
	$sql = "SELECT negate, id, name, sort_order FROM questions WHERE questionnaire_id = $questionnaire_id AND questiontype = 'gradedquestion' ORDER BY sort_order";
	$result = my_query($sql, $mysql_handler);
	
	$graded_questions_count = 0;
	
	if(mysql_num_rows($result) > 0)
	{
		$graded_questions_count = mysql_num_rows($result);
		$questionnaire_score_list = array();
		$questions = array();
		
		while ($rows = mysql_fetch_assoc($result))
		{
			$q_id = $rows['id'];
			$q_name = $rows['name'];
			$q_negate = $rows['negate'];
			$q_order = $rows['sort_order'];
			
			$questions[$q_id]['answers'] = array();
	
			//summerize score and get average for each answered question
			$answer_score_list = array();
			$answers_per_user = array();
			foreach($answ AS $answer_int_id => $answer_id)
			{
				$query = "SELECT response, answer_id FROM questionnaires_data WHERE question_id = $q_id AND answer_id = $answer_id";
				$query_result = my_query($query, $mysql_handler);

				$response = mysql_fetch_row($query_result);

				if ($q_negate)
					$response[0] *= -1;
	
				$answer_score_list[] = $response[0];
				$questions[$q_id]['answers'][$response[1]] = $response[0];
			}
			
			$answer_score = get_average($answer_score_list);
			
			$answer_median = get_median($answer_score_list);
	
			$questionnaire_score_list[] = $answer_score;
	
			// Get standard deviation
			$answer_stddeviation = get_stddeviation($answer_score_list);
	
			$questions[$q_id]['avg'] = $answer_score;
			$questions[$q_id]['median'] = $answer_median;
			$questions[$q_id]['stdd'] = $answer_stddeviation;
			$questions[$q_id]['neg'] = $q_negate;
			$questions[$q_id]['name'] = $q_name;
			$questions[$q_id]['order'] = $q_order;
		}
	}
	
	//Get average score for all questions
	$questionnaire_score = get_average($questionnaire_score_list);
	
	// Get questions per category
	if ($nmb_of_categories > 0)
	{
		$category_list = array();
		while ($categories = mysql_fetch_assoc($cat_result))
		{
			$cat_id = $categories['id'];
			$cat_name = $categories['name'];
	
			$category_list[$cat_id]['name'] = $cat_name;
			$category_list[$cat_id]['groups'] = array();
	
			$category_score_list = array();
	
			$sql = "SELECT q.id FROM in_category AS ic, questions AS q WHERE ic.category_id = $cat_id AND q.questionnaire_id = $questionnaire_id AND q.id = ic.question_id AND questiontype = 'gradedquestion' ORDER BY q.sort_order";
		
			$result = my_query($sql, $mysql_handler);
			$nmb_quest_in_cat = mysql_num_rows($result);
			
			if ($nmb_quest_in_cat > 0)
			{
				$answers_per_user = array();
				while ($rows = mysql_fetch_assoc($result))
				{
					$q_id = $rows['id'];
					$category_list[$cat_id]['questions'][] = $q_id;
					
					//Add answer score to the total category score
					$category_score_list[] = $questions[$q_id]['avg'];
					
					foreach($questions[$q_id]['answers'] AS $user => $value)
						$answers_per_user[$user][] = $value;
				}
	
				//Get average score for the category
				$category_list[$cat_id]['score'] = get_average($category_score_list);
				$category_list[$cat_id]['median'] = get_median($category_score_list);
				$category_list[$cat_id]['stdd'] = get_stddeviation($category_score_list);
	
				if ($master_question)
				{
					unset($answers_per_cat);
					// Get user scores
					foreach($answers_per_user AS $user => $answers)
					{
						$user_score = get_average($answers);
						foreach($masterq AS $name => $users)
						{
							if(in_array($user, $users['answers']))
							{
								$answers_per_cat[$name][] = $user_score;
							}
						}
					}
		
					//Write quartiles to array
					foreach($masterq AS $name => $users)
					{
						if(is_array($answers_per_cat[$name]))
						{
							//Write quartiles to array
							$category_list[$cat_id]['groups'][$name]['quartiles'] = get_quartiles($answers_per_cat[$name]);

							//Write answers to array
							$category_list[$cat_id]['groups'][$name]['answers'] = $answers_per_cat[$name];
						}
					}
		
					// Compare categories
					$inputarray = array();
					foreach($category_list[$cat_id]['groups'] AS $id => $value)
					{
						if(count($value['answers']) >= 5)
						{
							$inputarray[$id] = $value['answers'];
							$category_list[$cat_id]['groups'][$id]['comparable'] = true;
						}
						else
							$category_list[$cat_id]['groups'][$id]['comparable'] = false;
					}
					if(count($inputarray) > 1)
					{
						$differ = anova_kw_test($inputarray, 0.05);
						if(!$differ)
						{
							$temp_array = $inputarray;
							$i = 1;
							foreach($inputarray AS $id => $value)
							{
								if($i < count($inputarray))
								{
									$input = array();
									array_set_pointer($temp_array, $i);
									while(list($id2, $value2) = each($temp_array))
									{
										$input[] = $value;
										$input[] = $value2;
										if(!anova_kw_test($input, 0.05))
										{
											$category_list[$cat_id]['groups'][$id]['differs'][] = $id2;
										}
									}
								}
								$i++;
							}
						}
					}
				}
			}
		}
	}

	// Fetch multiple choice questions
	$sql = "SELECT id, name, sort_order FROM questions WHERE questionnaire_id = $questionnaire_id AND questiontype = 'multiple_choice' ORDER BY sort_order";
	$result = my_query($sql, $mysql_handler);
	
	$multichoice_questions_count = 0;
	
	if(mysql_num_rows($result) > 0)
	{
		$multichoice_questions_count = mysql_num_rows($result);
		$multichoice_questions = array();
		
		while ($rows = mysql_fetch_assoc($result))
		{
			$multichoice_questions[$rows['id']]['name'] = $rows['name'];
			$multichoice_questions[$rows['id']]['order'] = $rows['sort_order'];
			
			// Fetch alternatives
			$sql2 = "SELECT id, alternative FROM question_alternatives WHERE question_id = ".$rows['id']." ORDER BY sort_order";
			$result2 = my_query($sql2, $mysql_handler);
			while ($rows2 = mysql_fetch_assoc($result2))
			{
				$multichoice_questions[$rows['id']]['alternatives'][$rows2['alternative']] = 0;
			}

			// Fetch answers
			$sql2 = "SELECT answer_id, response FROM questionnaires_data WHERE question_id = ".$rows['id'];
			$result2 = my_query($sql2, $mysql_handler);
			while ($rows2 = mysql_fetch_assoc($result2))
			{
				if(in_array($rows2['answer_id'], $answ))
				{
					$multichoice_questions[$rows['id']]['alternatives'][$rows2['response']]++;
				}
			}

			// Recalculate to percents
			if(is_array($multichoice_questions[$rows['id']]['alternatives']))
			{
				foreach($multichoice_questions[$rows['id']]['alternatives'] AS $key => $value)
				{
					$multichoice_questions[$rows['id']]['alternatives'][$key] = $value/$nmb_of_full_answers*100;
				}
			}
		}
	}
	// Fetch number questions
	$sql = "SELECT id, name, sort_order FROM questions WHERE questionnaire_id = $questionnaire_id AND questiontype = 'number' ORDER BY sort_order";
	$result = my_query($sql, $mysql_handler);
	
	$number_questions_count = 0;
	
	if(mysql_num_rows($result) > 0)
	{
		$number_questions_count = mysql_num_rows($result);
		$number_questions = array();
		
		while ($rows = mysql_fetch_assoc($result))
		{
			$number_questions[$rows['id']]['name'] = $rows['name'];
			$number_questions[$rows['id']]['order'] = $rows['sort_order'];

			// Fetch answers
			$sql2 = "SELECT answer_id, response FROM questionnaires_data WHERE question_id = ".$rows['id'];
			$result2 = my_query($sql2, $mysql_handler);
			while ($rows2 = mysql_fetch_assoc($result2))
			{
				if(in_array($rows2['answer_id'], $answ))
				{
					$number_questions[$rows['id']]['answers'][] = $rows2['response'];
				}
			}
		}
	}	
}
?>