<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: manage_questionnaires_order.inc.php,v 1.14 2006/06/07 13:25:18 medea1 Exp $
*/

if(isset($_POST['cancel']))
{
	unset($_SESSION['move_questionnaires_data']);
	print_back("manage_questionnaires");
}

$pagetitle = "Move Questionnaires and Folders";

if(!isset($_SESSION['move_questionnaires_data']['target_id']))
{
	$error = false;

	foreach($_SESSION['move_questionnaires_data']['files'] AS $id)
	{
		if(!access_to_file($_SESSION['admin_id'], $id, $mysql_handler))
			$error = true;
	}

	foreach($_SESSION['move_questionnaires_data']['folders'] AS $id)
	{
		if(!access_to_folder($_SESSION['admin_id'], $id, $mysql_handler))
			$error = true;
	}
	
	if(is_numeric($_SESSION['move_questionnaires_data']['target_id']))
	{
		if(!access_to_folder($_SESSION['admin_id'], $_SESSION['move_questionnaires_data']['target_id'], $mysql_handler))
			$error = true;
	}

	if($error)
	{
		// Print pathborder
		$path[] = array('href' => '', 'name' => 'Move Questionnaires and Folders');
		$path_back = return_href('manage_questionnaires');
		$status[] = array('type' => 'error', 'text' => 'You can only move questionnaires or folders you own.');

		pageHeader($pagetitle, $path, $path_back, $status);
		pageFooter();
	}
	else
		include 'inc/select_folder.inc.php';
}
else
{
	$error_in_tree = false;
	$error_ownership = false;
	$error_target = false;

	foreach($_SESSION['move_questionnaires_data']['files'] AS $id)
	{
		if(!access_to_file($_SESSION['admin_id'], $id, $mysql_handler))
			$error_ownership = true;
	}

	foreach($_SESSION['move_questionnaires_data']['folders'] AS $id)
	{
		if(!access_to_folder($_SESSION['admin_id'], $id, $mysql_handler))
			$error_ownership = true;
	}

	if(!access_to_folder($_SESSION['admin_id'], $_SESSION['move_questionnaires_data']['target_id'], $mysql_handler))
		$error_target = true;

	foreach($_SESSION['move_questionnaires_data']['folders'] AS $id)
	{
		if(is_in_tree($id, $_SESSION['move_questionnaires_data']['target_id'], $mysql_handler))
			$error_in_tree = true;
	}

	if($error_target)
		$status[] = array('type' => 'error', 'text' => 'You can only move questionnaires or folders to a folder you own.');

	if($error_ownership)
		$status[] = array('type' => 'error', 'text' => 'You can only move questionnaires or folders you own.');
	
	if($error_in_tree)
		$status[] = array('type' => 'error', 'text' => 'You can\'t move folders into them self or their sub folders.');	


	

	if($error_in_tree || $error_ownership || $error_target)
	{
		include 'inc/select_folder.inc.php';
	}
	else
	{
		if(!isset($_POST['confirm']))
		{
			$path[] = array('href' => '', 'name' => 'Move Questionnaires and Folders');
			$path_back = return_href('manage_questionnaires');
	

			$status[] = array('type' => 'warning', 'text' => "Are you sure you wish to move the following questionnaires and folders to ".$_SESSION['move_questionnaires_data']['target_name']."?");

			pageHeader($pagetitle, $path, $path_back, $status);
	
			?>
				<form name="form_confirm" action="index.php" method="post">
				<input type="hidden" name="page" value="manage_questionnaires_order" />
					<table>
						<tr>
							<td colspan="2"><ul>

						<?php
						foreach($_SESSION['move_questionnaires_data']['folders'] AS $id)
						{
							echo "<li class=\"folder\">".get_parent_folders_string($id, $mysql_handler)."</li>"; 
						}
						foreach($_SESSION['move_questionnaires_data']['files'] AS $id)
						{
							$path = get_absolute_path_string($id, $mysql_handler);
							$sql = "SELECT name FROM questionnaires WHERE id = $id";
							$result = my_query($sql, $mysql_handler);
							$data = mysql_fetch_row($result);

							echo "<li class=\"questionnaire\">".$path.$data[0]."</li>";
						}
						?>
							</ul></td>
						</tr>
						<tr>
							<td><input type="submit" name="confirm" value="Confirm"  class="button_green button_normal" /></td>
							<td><input type="submit" name="cancel" value="Cancel" class="button_red button_normal" /></td>
						</tr>
					</table>
				</form>
			<?php
			pageFooter();
		}
		else
		{
		if(is_numeric($_SESSION['move_questionnaires_data']['target_id']) && !empty($_SESSION['move_questionnaires_data']['target_name']))
			{
				$target = $_SESSION['move_questionnaires_data']['target_id'];
				$target_name = $_SESSION['move_questionnaires_data']['target_name'];
		
				foreach($_SESSION['move_questionnaires_data']['files'] AS $id)
				{
					$sql = "UPDATE questionnaires SET folder_id = $target WHERE id = $id";
					my_query($sql, $mysql_handler);
				}
				foreach($_SESSION['move_questionnaires_data']['folders'] AS $id)
				{
					$sql = "UPDATE folders_questionnaires SET parent_folder = $target WHERE id = $id";
					my_query($sql, $mysql_handler);
				}
		
				print_back("manage_questionnaiers");
			}
		}
	}
}
?>
