<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: manage_questions.inc.php,v 1.52 2006/06/07 11:47:18 medea8 Exp $
*/

// Print pathborder
$path[] = array('href' => return_href('manage_questionnaire'), 'name' => 'Manage: '.$_SESSION['active_questionnaire_name']);
$path[] = array('href' => '', 'name' => 'Manage Questions');
$path_back = return_href('manage_questionnaire');

$pagetitle = 'Manage questions';

$error = 0;

//Confirm
if(isset($_SESSION['data_confirm']['list']) && $_SESSION['data_confirm']['page'] == 'action_manage_questions' && $_SESSION['data_confirm']['confirmed'] == true)
{
	if(!$_SESSION['owner_questionnaire'])
	{
		$status[] = array('type' => 'error', 'text' => 'Only the owner of a questionnaire can change the order of questions!');
		$error = 1;
	}
	else
		include_once('inc/delete_questions.inc.php');
}

if(is_numeric($_SESSION['active_questionnaire']))
{
	// Get master question
	$sql = "SELECT master_question FROM questionnaires WHERE id = ".$_SESSION['active_questionnaire'];
	$result = my_query($sql, $mysql_handler);
	$questionnaire_master = mysql_result($result, 0);
	
	if((isset($_REQUEST['move_down']) || isset($_REQUEST['move_up'])) && isset($_POST['rows']))
	{
		if(!$_SESSION['owner_questionnaire'])
		{
			print_status("error", "Only the owner of a questionnaire can change the order of questions!");
		}
		else
		{
			$questionnaire_id = $_SESSION['active_questionnaire'];
			
			if(isset($_REQUEST['move_down']))
				$arr = array_reverse($_POST['rows']);
			else
				$arr = $_POST['rows'];
		
		
			foreach($arr AS $id)
			{
				if(is_numeric($id))
				{
					$sql = "SELECT sort_order, id FROM questions WHERE questionnaire_id = $questionnaire_id ORDER by sort_order";
			
					$result = my_query($sql, $mysql_handler);
			
					$i = 0;
					$position = 0;
			
					while($data = mysql_fetch_assoc($result))
					{
						$q_id = $data['id'];
						$sort_order = $data['sort_order'];
			
						$arr[$sort_order] = $q_id;
						$i++;
			
						if($id == $q_id)
						{
							$position = $sort_order;
						}
					}
								
					if(isset($_REQUEST['move_up']))
					{
						if(!($position == 1))
						{
							$arr[$position] = $arr[$position-1];
							$arr[$position-1] = $id;
						}
			
					}
					elseif(isset($_REQUEST['move_down']))
					{
			
						if(!($position == $i))
						{	
							$arr[$position] = $arr[$position+1];
							$arr[$position+1] = $id;
						}
					}
					
					foreach($arr as $key => $value)
					{
						if(is_numeric($key) && is_numeric($value))
						{
							$sql = "UPDATE questions SET sort_order = $key WHERE id = $value";
							my_query($sql, $mysql_handler);
						}
					}
				}
			}
		}
	}
	
	if(!$_SESSION['owner_questionnaire'] && isset($_REQUEST['delete']))
	{
		$error = 1;
		$status[] = array('type' => 'error', 'text' => 'Only the owner of a questionnaire can delete questions in the questionnaire!');
	}
	
	$sql = "SELECT COUNT(*) FROM answers WHERE questionnaire_id = ".$_SESSION['active_questionnaire'];
	$result = my_query($sql, $mysql_handler);
	$answers = mysql_fetch_row($result);
	if($answers[0]>0)
	{
		$status[] = array('type' => 'warning', 'text' => 'There are answered questions in this questionnaire, do not change the meaning of questions. If you delete a question all answers for that question will be lost.', 'normal');
	}
	
	if(!$error && !$actionerror)
		$status[] = array('type' => 'description', 'text' => 'Select one or more questions that you wish to edit and then click on the appropriate button. Add a new question to the questionnaire with the "Append" button. By clicking on the "Preview" button you can preview the questionnaire.');

	pageHeader($pagetitle, $path, $path_back, $status);
	
	// Fetch questions which belong to selected questionary
	$sql = "SELECT id, name, negate FROM questions WHERE questionnaire_id = ".$_SESSION['active_questionnaire']." ORDER BY sort_order";
	
	
	$result = my_query($sql, $mysql_handler);
	
	?>
	<form name="zeus" action="index.php?page=action_manage_questions" method="post">
	<table><tr><td>
			<b>Select Question(s):</b><br/>
			<select name="rows[]" size="5" onchange="enable_object('modify');enable_object('move_up');enable_object('move_down');enable_object('delete');" multiple="multiple" id="select_questions">
	
	<?php
	while($row = mysql_fetch_assoc($result))
	{
		/*
		if( $row['id'] == $questionnaire_master && $row['negate'] == true)
			$row['name'] = '(*-)'.$row['name'];
		elseif( $row['id'] == $questionnaire_master )
			$row['name'] = '(*&nbsp;)'.$row['name'];
		elseif( $row['negate'] == true )
			$row['name'] = '(&nbsp;-)&nbsp;'.$row['name'];
		else
			$row['name'] = '(&nbsp;&nbsp;)&nbsp;'.$row['name'];
		*/
		if( $row['id'] == $questionnaire_master && $row['negate'] == true)
			$optionclass = 'master_negated';
		elseif( $row['id'] == $questionnaire_master )
			$optionclass = 'master_not_negated';
		elseif( $row['negate'] == true )
			$optionclass = 'not_master_negated';
		else
			$optionclass = 'not_master_not_negated';
		if( isset( $_POST['rows'] ) )
		{
			if(in_array($row['id'], $_POST['rows']) )
				echo '<option selected="selected" value="' . $row['id'] . '" class="tag_question_'.$optionclass.'">'.get_print_value($row['name'])."</option>\n";
			else
				echo '<option value="' . $row['id'] . '" class="tag_question_'.$optionclass.'">' .get_print_value($row['name']) ."</option>\n";
		}
		else
			echo '<option value="' . $row['id'] . '" class="tag_question_'.$optionclass.'">' .get_print_value($row['name']) ."</option>\n";
			
	}
	?>
			</select>
	</td><td valign="top"><br />
			<input type="submit" class="button_blue button_normal" name="append" id="append" value="Append" /><br /><br />
			<input type="submit" class="button_blue button_normal" name="modify" id="modify" value="Modify" /><br />
			<input type="submit" class="button_blue button_normal" name="delete" id="delete" value="Delete" /><br /><br />
			<input type="submit" class="button_blue button_normal" name="move_up" id="move_up" value="Move up" /><br />
			<input type="submit" class="button_blue button_normal" name="move_down" id="move_down" value="Move down" /><br />
			<input type="submit" class="button_blue button_normal" name="preview" id="preview" value="Preview" /><br />
		</td>
	</tr>
	</table>
		</form>
		<form name="cancel" action="index.php?page=manage_questionnaire" method="post"></form>
	<?php
		if((isset($_REQUEST['move_down']) || isset($_REQUEST['move_up'])) && isset($_POST['rows']))
			;
		else
		{
	?>
		
		<script language="javascript" type="text/javascript"> disable_object('modify');disable_object('move_up');disable_object('move_down');disable_object('delete');</script>
	<?php	}
	?>
	
	<b>	Description of color encoding:</b>
	<table>
		<tr>
			<td class="tag_question_not_master_not_negated info_frame" >&nbsp;</td>
			<td>Not master and not negated</td>
		</tr>
		<tr>
			<td class="tag_question_not_master_negated info_frame" >&nbsp;</td>
			<td>Not master and negated</td>
		</tr>
		<tr>
			<td class="tag_question_master_not_negated info_frame" >&nbsp;</td>
			<td>Master and not negated</td>
		</tr>
		<tr>
			<td  class="tag_question_master_negated info_frame" >&nbsp;</td>
			<td>Master and negated</td>
		</tr>
	</table>
	<i>Important: Color encoding of lines in list does not work in all web browsers</i>
<?php
}
pageFooter();
?>