<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.


*/

if(isset($_POST['folder_name']))
	$_SESSION['new_folder_data']['folder_name'] = $_POST['folder_name'];

if(isset($_POST['cancel']))
	print_back('manage_questionnaires');

if(!isset($_SESSION['new_folder_data']['parent_folder']['id']))
	$_SESSION['new_folder_data']['parent_folder']['id'] = 0;

if((!empty($_POST['folder_name'])) && isset($_POST['append_new_folder']) && $_POST['location_id'] != "" && is_numeric($_POST['location_id']) && $_POST['location_id'] >= 0)
{
	$folder_name = clean_string($_POST['folder_name']);

	$sql = "SELECT name FROM folders_questionnaires WHERE name = '$folder_name'";
	$result = my_query($sql, $mysql_handler);
	if(!($data = mysql_fetch_row($result)))
	{
		if(is_numeric($_POST['location_id']))
		{
			//Append Folder (name is now uniqe)
			$sql = "INSERT INTO folders_questionnaires (name, parent_folder, owner) VALUES ('$folder_name', '".$_POST['location_id']."', '".$_SESSION['admin_id']."');";
			my_query($sql, $mysql_handler);
		}
		print_back('manage_questionnaires');
	}
	else
	{
		$status[] = array('type' => 'error', 'text' => 'A Folder with that name already exists!', 'size' => 'normal');
	}
}

$error_folder = false;

if(isset($_SESSION['new_folder_data']['parent_folder']))
{
	if(is_numeric($_SESSION['new_folder_data']['parent_folder']['id']) && is_numeric($_SESSION['admin_id']))
		if(!access_to_folder($_SESSION['admin_id'], $_SESSION['new_folder_data']['parent_folder']['id'], $mysql_handler))
		{
			unset($_SESSION['new_folder_data']['parent_folder']);
			$_SESSION['new_folder_data']['parent_folder']['id'] = 0;
			$error_folder = true;
			$status[] = array('type' => 'error', 'text' => 'You are not the owner of the selected folder! Please select a new one.');
		}
}

if($error_folder || isset($_POST['select_location']))
{
	unset($path);
	include 'inc/select_folder.inc.php';
}
else
{
	if(isset($_POST['folder_name']) && empty($_POST['folder_name']))
		$status[] = array('type' => 'error', 'text' => 'You have to enter an unique name for the folder.');


	// Print pathborder
	$path[] = array('href' => '', 'name' => 'New Folder');
	$path_back = return_href('manage_questionnaires');
	
	$pagetitle = "New Folder";

	if(!error_to_report($status))
	{
		if($owns_no_folders)
			$status[] = array('type' => 'description', 'text' => 'You have to own a folder before creating a new questionnaire. <br />Add a new folder to the system. The name of the folder has to be uniqe to the system.');
		else
			$status[] = array('type' => 'description', 'text' => 'Add a new folder to the system. The name of the folder has to be uniqe to the system.');
	}
	pageHeader($pagetitle, $path, $path_back, $status);
	?>
	<form name="append_new_folder" action="index.php" method="post">
	<input type="hidden" name="page" value="new_folder" />
	<input type="hidden" name="location_id" value="<?php echo get_print_value($_SESSION['new_folder_data']['parent_folder']['id']); ?>" />	
	<table>
		<tr>
			<td colspan="2"><b>Folder name:</b></td>
		</tr>
		<tr>
			<td colspan="2"><input type="text" class="wide" name="folder_name" value="<?php echo get_print_value($_SESSION['new_folder_data']['folder_name']); ?>" /></td>
		</tr>
		<tr>
			<td colspan="2"><b>Create in folder:</b></td>
		</tr>
		<tr>
			<td>	<input type="text" class="wide" readonly="readonly" name="parent_folder" value="<?php echo "/".$_SESSION['new_folder_data']['parent_folder']['name']; ?>" /></td>
			<td><input type="submit" class="button_blue button_nearwide" name="select_location" value="Select Location" /></td>
		</tr>
		<tr>
			<td colspan="2"><input type="submit" class="button_green button_normal" name="append_new_folder" value="Save" />	<input type="submit" class="button_red button_normal" name="cancel" value="Cancel" /></td>
		</tr>
	</table>
	</form>
	<?php
	pageFooter();
}
	?>