<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: new_group.inc.php,v 1.3 2006/06/07 11:18:51 medea8 Exp $
*/

// Print pathborder
$path[] = array('href' => return_href('manage_questionnaire'), 'name' => 'Manage: '.$_SESSION['active_questionnaire_name']);
$path[] = array('href' => return_href('action_manage_questionnaire_users'), 'name' => 'Manage Users');
$path[] = array('href' => '', 'name' => 'New Group');

$path_back = return_href('action_manage_questionnaire_users');

$pagetitle = 'New Group';
$error = 0;

if($_SESSION['superuser'])
{
	if(isset($_SESSION['new_group_data']['parent_folder']))
	{
		if(is_numeric($_SESSION['admin_id']) && is_numeric($_SESSION['new_group_data']['parent_folder']['id']))
		{
			if(!access_to_folder($_SESSION['admin_id'], $_SESSION['new_group_data']['parent_folder']['id'], $mysql_handler))
			{
				unset($_SESSION['new_group_data']['parent_folder']);
				$_SESSION['new_group_data']['parent_folder']['id'] = 0;
				$status[] = array('type' => 'error', 'text' => 'You are not the owner of the selected folder!');
			}
		}
	}
	
	
	if((!empty($_POST['folder_name'])) && isset($_POST['add_new_group']) && $_POST['location_id'] != "")
	{
		$folder_name = clean_string($_POST['folder_name']);
		$location_id = clean_string($_POST['location_id']);
		if(is_numeric($_SESSION['admin_id']))
		{
			//Append Folder (name is now uniqe)
			$sql = "INSERT INTO folders_users (name, parent_folder, owner) VALUES ('$folder_name', '$location_id', '".$_SESSION['admin_id']."');";
			my_query($sql, $mysql_handler);
			print_back('manage_questionnaire_users');
		}
	}
	
	if(empty($_POST['folder_name']) && isset($_POST['append_new_folder']))
	{
		//Print info (no name)
		$status[] = array('type' => 'error', 'text' => 'Please enter a group name.');
		$error = 1;
	}
	
	if(isset($_POST['cancel']))
		print_back('manage_questionnaire_users');
	else
	{

		if(!$error)
			$status[] = array('type' => 'description', 'text' => 'Add a new group for users to the system.');

		pageHeader($pagetitle, $path, $path_back, $status);
	?>
	<form name="append_new_folder" action="index.php" method="post">
		<input type="hidden" name="page" value="action_new_group" />
		<input type="hidden" name="location_id" value="<?php echo get_print_value($_SESSION['new_group_data']['parent_folder']['id']); ?>" />	
		<table>
			<tr>
				<td colspan="2"><b>Group name:</b></td>
			</tr>
			<tr>
				<td colspan="2"><input type="text" class="wide" name="folder_name" value="<?php echo get_print_value($_SESSION['new_group_data']['folder_name']); ?>" /></td>
			</tr>
			<tr>
				<td colspan="2"><b>Create in group:</b></td>
			</tr>
			<tr>
				<td>	<input type="text" class="wide" readonly="readonly" name="parent_folder" value="<?php echo get_print_value("/".$_SESSION['new_group_data']['parent_folder']['name']); ?>" /></td>
				<td><input type="submit" class="button_blue button_nearwide" name="select_location" value="Select Location" /></td>
			</tr>
			<tr>
				<td colspan="2"><input type="submit" class="button_green button_normal" name="add_new_group" value="Save" />	<input type="submit" class="button_red button_normal" name="cancel" value="Cancel" /></td>
			</tr>
		</table>
	</form>
	<?php
		pageFooter();
	}
}
else
{
	$status[] = array('type' => 'error', 'text' => 'Only the superuser can create new groups');
	pageHeader($pagetitle, $path, $path_back, $status);
	pageFooter();
}
?>
