<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: new_questionnaire.inc.php,v 1.3 2006/06/07 13:46:40 medea1 Exp $
*/

$owns_no_folders = false;
$sql = "SELECT id FROM folders_questionnaires WHERE owner = ".$_SESSION['admin_id'];
$result = my_query($sql, $mysql_handler);

if(mysql_num_rows($result) == 0 && !$_SESSION['superuser'])
	$owns_no_folders = true;
elseif($_SESSION['superuser'])
{
	$sql = "SELECT id FROM folders_questionnaires";
	$result = my_query($sql, $mysql_handler);
	$data = mysql_fetch_row($result);
	if(!isset($data[0]))
		$owns_no_folders = true;
}

// Can't create a questionnaire if the user doesn't own any folders.
if($owns_no_folders)
{
	include_once('inc/new_folder.inc.php');
	
}
else
{
	// Print pathborder
	$path[] = array('href' => '', 'name' => 'New Questionnaire');
	$path_back = return_href('manage_questionnaires');
	
	// Set pagetitle and status
	$pagetitle = 'New Questionnaire';
	
	if(isset($_POST['cancel']))
	{
		unset($_SESSION['new_questionnaire_data']);
		print_back("manage_questionnaires");
	}
	
	$error_time = 0;
	
	if(isset($_POST['save_new_questionnaire']) && is_numeric($_POST['location_id']) && $_POST['location_id'] >= 0)
	{
		if(isset($_REQUEST['name']))
			$_SESSION['new_questionnaire_data']['name'] = $_REQUEST['name'];
		if(isset($_REQUEST['description']))
			$_SESSION['new_questionnaire_data']['description'] = $_REQUEST['description'];
	
	
		$name = str_replace("/","",$_POST['name']);
		$name = clean_string($name);
	
		$description = clean_string($_POST['description']);
	
	
		if(!empty($_POST['deadline']) && is_numeric($_POST['deadline']) && $_POST['deadline'] > 0)
			$deadline = $_POST['deadline'];
		else
			$deadline = 0;
	
		$folder_id = $_POST['location_id'];
	
		$error_insert = false;
	
		if(empty($name))
		{
			$status[] = array('type' => 'error', 'text' => 'You have to enter a name for the new questionnaire.');
			$error_insert = true;
		}
	
		if(!is_numeric($folder_id) || $folder_id <= 0)
		{
			$status[] = array('type' => 'error', 'text' => 'You have to select a location for the new questionnaire.');
			$error_insert = true;
		}
		
	
		if(!$error_insert)
		{
			$sql = "INSERT INTO questionnaires (name, description, deadline, folder_id, owner) VALUES ('$name', '$description', $deadline, $folder_id,".$_SESSION['admin_id'].");";
			my_query($sql,$mysql_handler);
			
			$insertid = mysql_insert_id();
		
			$sql = "INSERT INTO question_categories (name, questionnaire_id) VALUES ('none', $insertid)";
			my_query($sql,$mysql_handler);
		
			unset($_SESSION['new_questionnaire_data']);
		
			print_back('manage_questionnaires');
		}
	}
	
	
	$error_folder = false;
	$error_deadline = false;
	
	if(isset($_SESSION['new_questionnaire_data']['parent_folder']))
	{
		if(is_numeric($_SESSION['new_questionnaire_data']['parent_folder']['id']) && is_numeric($_SESSION['admin_id']))
			if(!access_to_folder($_SESSION['admin_id'], $_SESSION['new_questionnaire_data']['parent_folder']['id'], $mysql_handler))
			{
				unset($_SESSION['new_questionnaire_data']['parent_folder']);
				$_SESSION['new_questionnaire_data']['parent_folder']['id'] = 0;
				$error_folder = true;
				$status[] = array('type' => 'error', 'text' => 'You are not the owner of the selected folder! Please select a new one.');
			}
	}
	
	if($error_folder || isset($_POST['select_location']))
	{
		if(isset($_REQUEST['name']))
			$_SESSION['new_questionnaire_data']['name'] = $_REQUEST['name'];
		if(isset($_REQUEST['description']))
			$_SESSION['new_questionnaire_data']['description'] = $_REQUEST['description'];
	
		unset($path);
		include 'inc/select_folder.inc.php';
	}
	elseif($error_deadline || isset($_POST['select_deadline']))
	{
		if(isset($_REQUEST['name']))
			$_SESSION['new_questionnaire_data']['name'] = $_REQUEST['name'];
		if(isset($_REQUEST['description']))
			$_SESSION['new_questionnaire_data']['description'] = $_REQUEST['description'];
	
		unset($path);
		include 'inc/select_date.inc.php';
	}
	else
	{
		if(isset($_REQUEST['time']))
		{
		
			$year = date('Y', $_REQUEST['time']);
			$month = date('m', $_REQUEST['time']);
			$day = date('d', $_REQUEST['time']);
			
			$time = mktime(0,0,0,$month, $day, $year);
			if($time < time())
			{
				$status[] = array('type' => 'error', 'text' => "You tried to set the deadline for the questionnaire to a date in the past.", 'size' => 'normal');
				$error_time = 1;
		
			}
			else
				$_SESSION['new_questionnaire_data']['time'] = $time;
		}
		
		if(!$error_insert && !$error_time)
			$status[] = array('type' => 'description', 'text' => 'Add a new questionnaire to the system.');
		
		pageHeader($pagetitle, $path, $path_back, $status);
		?>
	
		<form name="properties" action="index.php" method="post">
		<input type="hidden" name="location_id" value="<?php if(isset($_SESSION['new_questionnaire_data']['parent_folder']['id'])) echo $_SESSION['new_questionnaire_data']['parent_folder']['id']; else echo 0; ?>" />	
		<table>
			<tr>
	
				<td rowspan="2" valign="top">
					<input type="hidden" name="page" value="new_questionnaire" />
					<b>Questionnarie name:</b><br/>
					<input type="text" class="wide" name="name" value="<?php echo get_print_value($_SESSION['new_questionnaire_data']['name']); ?>" /><br />
					<br/>
					<b>Questionnarie description:</b><br/>
					<textarea name="description" class="wide" rows="10" cols="40"><?php echo get_print_value($_SESSION['new_questionnaire_data']['description']); ?></textarea><br />
					<br/>
					<b>Questionnarie deadline:</b><br/>
					<input type="text" class="wide" name="deadlinetext" readonly="readonly" value="<?php if(isset($_SESSION['new_questionnaire_data']['time'])) echo date('Y-m-d', $_SESSION['new_questionnaire_data']['time']); ?>" /><br />
					<input type="hidden" class="wide" name="deadline" value="<?php echo  $_SESSION['new_questionnaire_data']['time']; ?>" />
			
				</td>
		
				<td  valign="top">
					<input type="hidden" name="send_to" value="new_questionnaire" />
					<br />
					<input type="submit" class="button_green button_nearwide" name="save_new_questionnaire" value="Save" />
					<br />
					<input type="submit" class="button_red button_nearwide" name="cancel" value="Cancel" />
				</td>
			</tr>
		
			<tr>
				<td valign="bottom">
					<input type="submit" style="margin-bottom:0px" class="button_blue button_nearwide" name="select_deadline" value="Select deadline" />
				</td>
			</tr>
	
			<tr>
				<td>	<b>Questionnarie location:</b><br/>
				<input type="text" class="wide" readonly="readonly" name="parent_folder" value="<?php echo $_SESSION['new_questionnaire_data']['parent_folder']['name']; ?>" /></td>
				<td valign="bottom"><input type="submit" style="margin-bottom:0px" class="button_blue button_nearwide" name="select_location" value="Select location" /></td>
			</tr>
		</table>
		
		</form>
		<?php
		pageFooter();
	}
}
?>