<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: questionnaire_properties.inc.php,v 1.37 2006/06/08 09:45:38 medea8 Exp $
*/

$error = 0;

// Print pathborder
$path[] = array('href' => return_href('manage_questionnaire'), 'name' => 'Manage: '.$_SESSION['active_questionnaire_name']);
$path[] = array('href' => '', 'name' => 'Properties');
$path_back = return_href('manage_questionnaire');

$pagetitle = "Properties";

if(isset($_REQUEST['time']))
{
	$year = date('Y', $_REQUEST['time']);
	$month = date('m', $_REQUEST['time']);
	$day = date('d', $_REQUEST['time']);
	
	$time = mktime(0,0,0,$month, $day+1, $year)-1;
	
	if($time < time())
	{
		$status[] = array('type' => 'warning', 'text' => 'You set the deadline for the questionnaire to a date in the past. The questionnaire cannot garantee its anonymity to the users when deadline has passed.');
		$error = 1;
	}
}

if(!empty($_POST['save_questionnaire_properties']) && !empty($_POST['name']))
{
	if(!$_SESSION['owner_questionnaire'])
	{
		$status[] = array('type' => 'error', 'text' => 'Only the owner of the questionnaire can change the questionnaire properties!');
		$error = 1;
	}
	else
	{
		$deadline = clean_string($_POST['deadline']);
		$name = clean_string($_POST['name']);
		$description = clean_string($_POST['description']);
		$email_text = clean_string($_POST['email_text']);

		$sql = "UPDATE questionnaires SET name = '$name', description = '$description', deadline = '$deadline', email_text = '$email_text' WHERE id = " . $_SESSION['active_questionnaire'];
	
		$result = my_query($sql,$mysql_handler);
	
		unset($_SESSION['append_deadline_description']);
		unset($_SESSION['append_deadline_name']);
		unset($_SESSION['email_text']);

		// Get questionnaire path
		$sql = "SELECT name FROM questionnaires WHERE id = '" . $_SESSION['active_questionnaire'] . "'";
		$result = my_query($sql, $mysql_handler);
		$questionnaire_name = mysql_result($result, 0);
		$path = get_absolute_path_string($_SESSION['active_questionnaire'], $mysql_handler, ', ');
		$_SESSION['active_questionnaire_name'] = $path . $questionnaire_name;

		if(isset($_SESSION['questionnaire_properties_publish_deadline']))
		{
			unset($_SESSION['questionnaire_properties_publish_deadline']);
			print_back('manage_questionnaire', 'publish=true');
		}
		else
			print_back('manage_questionnaire');
	}
}
else
{
	if(!isset($_SESSION['append_deadline_name']) && !isset($_SESSION['append_deadline_description']) && !isset($_SESSION['email_text']) && is_numeric($_SESSION['active_questionnaire']))
	{
		$sql = "SELECT name, description, deadline, email_text FROM questionnaires WHERE id = ".$_SESSION['active_questionnaire'];
		$result = my_query($sql,$mysql_handler);
		$questioninfo = mysql_fetch_assoc($result);
	}
	else
	{
		$questioninfo['name'] = $_SESSION['append_deadline_name'];
		$questioninfo['description'] = $_SESSION['append_deadline_description'];
		$questioninfo['email_text'] = $_SESSION['email_text'];
	}

	if(isset($_SESSION['questionnaire_properties_publish_deadline']))
	{
		$status[] = array('type' => 'error', 'text' => 'Before you can publish the questionnaire you must set a valid deadline.');
		$error = 1;
	}

	if(empty($_POST['name']) && isset($_POST['name']))
	{
		$status[] = array('type' => 'error', 'text' => 'The questionnaire has to have a valid name.');
		$error = 1;
	}

	if(empty($questioninfo['email_text']))
	{
			$result = mysql_fetch_row(my_query("SELECT email_text FROM site_properties",$mysql_handler));
			$questioninfo['email_text'] = $result[0];
	}

	if(!$error)
		$status[] = array('type' => 'description', 'text' => 'The properties of the questionnaire.');
	pageHeader($pagetitle, $path, $path_back, $status);
	?>

		<form name="properties" action="index.php" method="post">
	
	<table>
	<tr>
	<td rowspan="2">
			<b>Questionnaire name:</b><br />
			<input type="hidden" name="page" value="action_questionnaire_properties" />
	
			<input type="text" class="wide" name="name" value="<?php if(isset($_POST['name'])) echo get_print_value($_POST['name']); else  echo get_print_value($questioninfo['name']); ?>" /><br /><br />
			<b>Description name:</b><br />
			<textarea rows="4" cols="4" class="wide" name="description"><?php if(isset($_POST['description'])) echo get_print_value($_POST['description']); else  echo get_print_value($questioninfo['description']); ?></textarea><br />
			<br /><b>Deadline</b><br />
			<input type="text" class="wide" name="deadlinetext" readonly="readonly" value="<?php if(isset($time)) echo date('Y-m-d', $time); elseif(!empty($questioninfo['deadline'])) echo date('Y-m-d', $questioninfo['deadline']); ?>" />
			<input type="hidden" name="deadline" value="<?php if(isset($questioninfo['deadline'])) echo get_print_value($questioninfo['deadline']); else echo get_print_value($time); ?>" />
			<input type="hidden" name="send_to" value="questionnaire_properties" />
	
	</td>
	<td  valign="top">&nbsp;<br/><input type="submit" class="button_green button_nearwide" name="save_questionnaire_properties" value="Save" /><br /><input type="submit" class="button_red button_nearwide" name="cancel" value="Cancel" /></td>
	</tr>
	<tr><td valign="bottom" colspan="2"><input style="margin-bottom: 0px;" type="submit" class="button_blue button_nearwide" name="select_deadline" value="Select deadline" /></td></tr>
	<tr>
		<td colspan="2">
			<b>E-mail text:</b><br />
			<textarea rows="4" class="wide" cols="4" name="email_text"><?php if(isset($_POST['email_text'])) echo get_print_value($_POST['email_text']); else echo get_print_value($questioninfo['email_text']);?></textarea>
		</td>
	</tr>
	</table>
	</form>
	
	<?php

	$result = my_query("SELECT site_user_site FROM site_properties",$mysql_handler);
	$site_user_site = mysql_result($result, 0);
	
	if(isset($questioninfo['deadline']))
		$datum = date("Y-m-d",$questioninfo['deadline']);
	else
		$datum = date("Y-m-d",$time);

	if(isset($_POST['name'])) 
		$a = get_print_value($_POST['name']);
	else
		$a = get_print_value($questioninfo['name']);
	
	if(isset($_POST['description'])) 
		$b = get_print_value($_POST['description']);
	else
		$b = get_print_value($questioninfo['description']);
	
	print_status("info", "Available keywords are:<br /><i>!questionnaire_name!</i> - Is replaced by your questionnaire name (<i>$a</i>)<br /><i>!questionnaire_desc!</i> - Is replaced by your questionnaire description (<i>$b</i>)<br /><i>!questionnaire_deadline!</i> - Is replaced by your deadline (<i>$datum</i>)<br /><i>!usersite_url!</i> - Is replaced by the usersite URL (<i>$site_user_site</i>)", "normal");
	
}
pageFooter();
?>