<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: report_substantial.inc.php,v 1.7 2006/06/07 13:00:42 medea7 Exp $
*/

// PDF creation
if($print_file)
{
	// Headers
	$headers = array();
	
	// Data
	$data[] = array('Number of questions:', $nmb_of_questions);
	$data[] = array('Number of answers:', $nmb_of_answers);
	$data[] = array('Fully answered:', $nmb_of_full_answers);
	$data[] = array('Number of assigned users:', $nmb_of_users);
	if ($nmb_of_answers > 0)
		$freq = number_format(($nmb_of_answers/$nmb_of_users)*100,1,".","") . "%";
	else
		$freq = "0 %";
	$data[] = array('Answer frequency:', $freq);

	// width
	$width = array(50, 20);

	// align
	$align = array('L', 'R');

	$pdf->print_h2('Substantial facts');

	$pdf->FancyTable($headers, $data, $width, $align, array(), array($row_color1, $row_color2));
}
else
{
?>
<table class="report_substantial">
	<tr bgcolor="<?php echo $row_color1; ?>">
		<td width="75%">Number of questions:</td>
		<td><?php echo $nmb_of_questions; ?></td>
	</tr>
	<tr bgcolor="<?php echo $row_color2; ?>">
		<td>Number of answers:</td>
		<td><?php echo $nmb_of_answers; ?></td>
	</tr>
	<tr bgcolor="<?php echo $row_color1; ?>">
		<td>Fully answered:</td>
		<td><?php echo $nmb_of_full_answers; ?></td>
	</tr>
	<tr bgcolor="<?php echo $row_color2; ?>">
		<td>Number of assigned users:</td>
		<td><?php echo $nmb_of_users; ?></td>
	</tr>
	<tr bgcolor="<?php echo $row_color1; ?>">
		<td>Answer frequency:</td>
		<td>
<?php 
		//Calculate frequency
		if ($nmb_of_answers > 0)
			echo number_format(($nmb_of_answers/$nmb_of_users)*100,1,".","") . "%";
		else
			echo "0 %";
?>
		</td>
	</tr>
</table>
<?php
}
?>