<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: show_log.inc.php,v 1.10 2006/06/06 12:30:23 medea7 Exp $
*/

// Print pathborder
$path[] = array('href' => return_href('maintenance'), 'name' => 'System maintenance');
$path[] = array('href' => '', 'name' => 'Show log');

$path_back = return_href('maintenance');

$pagetitle = 'Log';

$logfile = './logs/querys.log';

function read_logfiles($files, $lines=5)
{
	foreach($files as $file_num => $file) {
		if (!file_exists ($file) ) {
			$text[$file_num] = "Logfile doesn't exist.";
		}
		elseif (filesize($file) == 0 ) {
			$text[$file_num] = "Logfile is empty.";
		}
		else {
			$handle = fopen($file, "r");
			$linecounter = $lines;
			$pos = -1;
			$t = " ";
			$begin_of_file = filesize($file);
			$text[$file_num] = "";
			while ($linecounter > 0 && ($begin_of_file+$pos) > -1) {
				while ($t != "\n" && ($begin_of_file+$pos) > -1) {
					fseek($handle, $pos, SEEK_END);
					$t = fgetc($handle);
					$pos --;
				}
				if(($begin_of_file+$pos) == -1)
					rewind($handle);
				$t = " ";
				$text[$file_num] .= fgets($handle);
				$linecounter --;
			}
			fclose ($handle);
		}
	}

	return $text;
}

function truncate_logfiles($files)
{
	foreach($files as $file_num => $file) {
		if (file_exists ($file) ) {
			$handle = fopen($file, "w");
			ftruncate($handle, 0);
			fclose($handle);
		}
	}
}

if(isset($_POST['truncate']))
{
	truncate_logfiles(array($logfile));
}

if(isset($_POST['export']) && $_SESSION['superuser'])
{
	// Send file to browser
	header("Content-type: text/plain");
	header("Content-Disposition: attachment; filename=querys.log");
	readfile($logfile);
}
else
{
	pageHeader($pagetitle, $path, $path_back);
	if($_SESSION['superuser'])
	{
?>
		<?php print_status('description', 'The system log.'); ?>
		<form name="log" action="index.php" method="POST">
		<input type="hidden" name="page" value="show_log" />
		<textarea id="logfield" name="Log" rows="8" cols="70" readonly="readonly">
<?php
			if(isset($_POST['show_all']))
				readfile($logfile);
			else
			{
				$log = read_logfiles(array($logfile), 1000);
				echo $log[0];
			}
?>
		</textarea><br />
<?php
		if(isset($_POST['show_all']))
			echo '<input type="submit" name="show_1000" class="button_blue button_nearwide" value="Show last rows" />';
		else
			echo '<input type="submit" name="show_all" class="button_blue button_nearwide" value="Show all rows" />';
?>
		<input type="submit" name="truncate" class="button_blue button_nearwide" value="Delete log" />
		<input type="submit" name="export" class="button_blue button_nearwide" value="Export log" />
		</form>
<?php
	}
	else
		print_status('error', 'You are not allowed to view this page.', 'normal');

	pageFooter();
}
?>