<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: function_plotting.inc.php,v 1.2 2006/06/07 12:00:53 medea3 Exp $
*/

// $argument = array($min, $q1, $median, $q3, $max)
function print_boxplot($argument)
{
	echo('<img src="plotting/create_boxplot.php?max='.$argument[4].'&amp;min='.$argument[0].'&amp;q1='.$argument[1].'&amp;q3='.$argument[3].'&amp;median='.$argument[2].'" alt="Boxplot" />');
}

// $argument = array('<label>' => array($min, $q1, $median, $q3, $max))
function print_multiboxplot($title, $argument)
{
	$src = return_multiboxplot_link($title, $argument);
	echo('<img src="'.$src.'" alt="Boxplot" />');
}

function return_multiboxplot_link($title, $argument)
{
	$src = 'plotting/create_multiboxplot.php?title='.$title;
	foreach($argument AS $label => $values)
	{
		$src .= '&amp;labels[]='.$label.'&amp;min[]='.$values[0].'&amp;max[]='.$values[4].'&amp;q1[]='.$values[1].'&amp;q3[]='.$values[3].'&amp;median[]='.$values[2];
	}
	return $src;
}

// $argument = array('<label>' => <percent>)
function print_piechart($argument, $title='')
{
	$src = return_piechart_link($argument, $title);
	echo('<img src="'.$src.'" alt="Piechart" />');
}

function return_piechart_link($argument, $title='')
{
	$src = 'plotting/create_piechart.php?title='.$title;
	foreach($argument AS $label => $percent)
	{
		$src .= '&amp;labels[]='.$label.'&amp;percents[]='.$percent;
	}
	return $src;
}

function print_bar_plot($argument, $title='', $x_label='', $y_label='', $origo='')
{
	$src = return_bar_plot_link($argument, $title, $x_label, $y_label, $origo);
	echo('<img src="'.$src.'" alt="Bar plot" />');
}

function return_bar_plot_link($argument, $title='', $x_label='', $y_label='', $origo='')
{
	$src = 'plotting/create_bar_plot.php?title='.$title . '&amp;x_label='.$x_label.'&amp;y_label='.$y_label.'&amp;origo='.$origo;
	foreach($argument AS $label => $value)
	{
		$src .= '&amp;labels[]='.$label.'&amp;value[]='.$value;
	}
	return $src;
}

function print_histogram_plot($argument, $title='', $x_label='', $y_label='', $origo='')
{
	$src = return_histogram_plot_link($argument, $title, $x_label, $y_label, $origo);
	echo('<img src="'.$src.'" alt="Histogram plot" />');
}

function return_histogram_plot_link($argument, $title='', $x_label='', $y_label='', $origo='')
{
	$src = 'plotting/create_histogram_plot.php?title='.$title . '&amp;x_label='.$x_label.'&amp;y_label='.$y_label.'&amp;origo='.$origo;
	foreach($argument AS $label => $value)
	{
		$src .= '&amp;labels[]='.$label.'&amp;value[]='.$value['count'].'&amp;min[]='.$value['min'].'&amp;max[]='.$value['max'];
	}
	return $src;
}
?>