<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: function_print_status.inc.php,v 1.8 2006/05/31 11:02:47 medea8 Exp $
*/

	function print_status($type, $text, $def_size = "small")
{
	$valid_types = array("info", "ok", "error", "warning", "description");
	$valid_sizes = array("tiny", "small", "normal", "large", "giant");
	
	$num = array_search($def_size, $valid_sizes);
	$large_num = $num + 1;

	if($_SESSION['page_size'] == 'large')
		$size = $valid_sizes[$large_num];
	else
		$size = $def_size;

	if(in_array($type, $valid_types) && in_array($size, $valid_sizes))
	{
		if($type == "description")
			$type0 = "info";
		else
			$type0 = $type;
?>
		<table>
			<tr>
				<td width="36"><img src="img/zeus_<?php echo $type0.'_'.$size;?>.png" alt="<?php echo $type0; ?>" /></td>
				<td class="<?php echo $type; ?>"><?php echo $text; ?></td>
			</tr>
		</table><br />
<?php
	}else{
		if( !in_array($type, $valid_types) )
		{
			foreach($valid_types as $valid_type)
			{
				$echo_str .= $valid_type.', ';
			}
			$echo_str = substr($echo_str, 0, strlen($echo_str)-strlen(', '));
			echo 'print_status(): Invalid argument type, valid types are: '.$echo_str;
		}
		if( !in_array($size, $valid_sizes) )
		{
			foreach($valid_sizes as $valid_size)
			{
				$echo_str .= $valid_size.', ';
			}
			$echo_str = substr($echo_str, 0, strlen($echo_str)-strlen(', '));
			echo 'print_status(): Invalid argument size, valid sizes are: '.$echo_str;
		}
	}
}
?>
