<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: questions.inc.php,v 1.69 2006/06/07 09:33:21 medea2 Exp $
*/

//The questionnaire ID is either sent from the selectbox (previous page) or from a hidden field. If none of them are set something went wrong and we go back to the select questionnaire page.
if(isset($_REQUEST['select_questionnaire']) && is_numeric($_REQUEST['select_questionnaire']))
	$questionnaire_id = clean_string($_REQUEST['select_questionnaire']);

elseif(isset($_POST['questionnaire_id']) && is_numeric($_POST['questionnaire_id']))
	$questionnaire_id = clean_string($_POST['questionnaire_id']);

else
{
	print_back('select_questionnaire');
}

if($_SESSION['page_size'] == 'large')
	$large = "_large";
else
	$large = "";

//Print questionnaire name and description
$sql = "SELECT name, description, deadline FROM questionnaires WHERE id = " . $questionnaire_id;
$result = my_query($sql, $mysql_handler);
$selected_sql = mysql_fetch_assoc($result);

$deadline = $selected_sql['deadline'];

$pagetitle = $selected_sql['name'] . " - <i>Deadline " . date("Y-m-d H:i", $deadline) . "</i>";

if (time() < $deadline)
	$deadline_txt = "<br />The deadline has not passed, your answers will be completely anonymous.";
else
	$status[] = array('type' => 'warning', 'text' => 'The deadline has passed. Your answers may not be completely anonymous in the answer database.');



$status[] = array('type' => 'description', 'text' => $selected_sql['description'] . $deadline_txt);


if(isset($_POST['cancel']))
{
	print_back('select_questionnaire');
}

$unanswered = array();

pageHeader($pagetitle, $status);

if(isset($_POST['submit_questionnaire']))
{
	$sql = "SELECT id, questiontype, several FROM questions WHERE questionnaire_id = $questionnaire_id";
	$result = mysql_query($sql, $mysql_handler);
	$question_ids = array();
	
	while($answers = mysql_fetch_assoc($result))
	{
		$id = $answers['id'];
		$question_ids[] = $id;
		$question_types[] = $answers['questiontype'];
		
		if(!isset($_POST['noanswer'][$id]))
		{
			if(!isset($_POST['reply'][$id]))
				$unanswered[] = $id;

			elseif($answers['questiontype'] == 'number')
			{
				if( empty($_POST['reply'][$id]))
					$unanswered[] = $id;

				if(!is_numeric($_POST['reply'][$id]))
					$unanswered[] = $id;
			}
			elseif($answers['questiontype'] == 'multiple_choice')
			{
				if($answers['several'] == 0 && count($_POST['reply'][$id]) != 1)
					$unanswered[] = $id;
			}
			elseif($answers['questiontype'] == 'textquestion' && empty($_POST['reply'][$id]))
				$unanswered[] = $id;
		}
	}
	
	if(!empty($unanswered))
	{
		print_status("warning",'You have not correctly answered all questions in the questionnaire!<br />
				Your answer is important to us, if you do not answer all of the questions<br />
				we cannot generate reliable statistics.');
		$_POST['retake'] = true;
	}
	else
	{
		$sql = "SELECT response_time FROM questionnaires_users WHERE questionnaire_id = $questionnaire_id AND user_id = {$_SESSION['user_id']};";
		$result = mysql_query($sql, $mysql_handler);
		$time = mysql_fetch_row($result);
		
		if($time[0] > 0)
		{
			print_status('error', 'You have already answered this questionnaire!', 'normal');
			$hide_form = true;
?>
			<form name="questionnaire" action="index.php" method="post">
			<input type="hidden" name="page" value="select_questionnaires" />

			<table cellspacing="0" cellpadding="0" border="0">
				<tr>
				<td><input type="submit" class="button_green button_normal" name="back" value="Back" /></td>
				</tr>
			</table>
			</form>
<?php
		}

		else
		{
			// Generate unique id
			$found_available = false;
			while(!$found_available)
			{
				$answer_id = mt_rand();
				$sql = "SELECT COUNT(*) FROM answers WHERE answer_id = ".$answer_id;
				$result = my_query($sql, $mysql_handler);
				$rows = mysql_result($result, 0);
				if($rows < 1)
					$found_available = true;
			}
			$sql = "INSERT INTO answers SET answer_id = ".$answer_id.", questionnaire_id = $questionnaire_id";
			$commit = my_query($sql, $mysql_handler);
			
			foreach($question_ids AS $int_id => $q_id)
			{
				if(!isset($_POST['noanswer'][$q_id]) && is_numeric($q_id))
				{
					// Multiple answers
					if($question_types[$int_id] == 'multiple_choice')
					{
						foreach($_POST['reply'][$q_id] AS $answer_value)
						{
							$reply = clean_string($answer_value);
							$sql = "INSERT INTO questionnaires_data (answer_id, question_id, response) VALUES ($answer_id, $q_id, '$reply')";
							mysql_query($sql, $mysql_handler);
						}
					}
					else
					{
						$reply = clean_string($_POST['reply'][$q_id]);
						$sql = "INSERT INTO questionnaires_data (answer_id, question_id, response) VALUES ($answer_id, $q_id, '$reply')";
						mysql_query($sql, $mysql_handler);
					}
				}
			}
			
			
			$time = time();
			$sql = "UPDATE questionnaires_users SET response_time = $time WHERE questionnaire_id = $questionnaire_id AND user_id = {$_SESSION['user_id']};";
			$commit = my_query($sql, $mysql_handler);
			
			print_status('ok', 'Your answers have been registrated!<br/><i>Thank you</i> for participating in the questionnaire.', 'normal');

			$hide_form = true;
?>
			<form name="questionnaire" action="index.php" method="post">
			<input type="hidden" name="page" value="select_questionnaires" />

			<table cellspacing="0" cellpadding="0" border="0">
				<tr>
				<td><input type="submit" class="button_green button_normal" name="back" value="Back" /></td>
				</tr>
			</table>
			</form>
<?php
		}
	}
}

//Get Color
$get_color_sql = "SELECT question_row_color1, question_row_color2 FROM site_properties WHERE id = 1;";
$result = my_query($get_color_sql, $mysql_handler);
$colors = mysql_fetch_assoc($result);

$color1 = $colors['question_row_color1'];
$color2 = $colors['question_row_color2'];

//Fetch questions for the requested questionnaire
$sql = "SELECT id, name, questiontype, number_of_rows, several FROM questions WHERE questionnaire_id = $questionnaire_id ORDER BY sort_order";
$result = my_query($sql, $mysql_handler);

if(!$hide_form)
{
?>

<form name="questionnaire" action="index.php" method="post">
<input type="hidden" name="page" value="questions" />

	<table cellspacing="0" cellpadding="0" border="0">
<?php
	for($i = 0; $questions = mysql_fetch_assoc($result); $i++, $lastquestiontype = $questions['questiontype'])
	{
		$id = $questions['id'];
		
		if($lastquestiontype == $questions['questiontype'])
			list($table_bgcolor, $table_bgcolor2) = array($table_bgcolor2, $table_bgcolor);
		else
		{
			$table_bgcolor = $color1;
			$table_bgcolor2 = $color2;
		}
		
		echo "\n".'<tr><td>'."\n";
		if($questions['questiontype'] == 'gradedquestion')
		{
			if($lastquestiontype != 'gradedquestion')
			{
?>
			<table cellspacing="0" cellpadding="0" border="0">
			<tr bgcolor="<?php echo $table_bgcolor2;?>">
				<td class="question_td"><b>Question</b></td>
				<td class="question_fullyd" align="left"><b>Fully<br />disagree</b></td>
				<td class="question_fullya" align="right"><b>Fully<br />agree</b></td>
				<td class="question_noansw" align="right"><b><?php if(isset($_POST['retake'])) echo 'No<br/>answer'; else echo '&nbsp;';?></b></td>
			</tr>
			</table>
			</td></tr>
			<tr><td>
<?php
			}
?>
			<table cellspacing="0" cellpadding="0" border="0">
			<tr bgcolor="<?php echo $table_bgcolor;?>">
				<td class="question_td"><img src="img/zeus_question<?php echo $large; ?>.gif" style="vertical-align: middle;" alt="question" />&nbsp;<?php echo $questions['name']; ?></td>
				
				<td class="question_radio_td"><input type="radio" class="radio" name="reply[<?php echo $id; ?>]" value="-100" <?php if($_POST['reply'][$id] == '-100') echo 'checked="checked"'; ?> /></td>
				<td class="question_radio_td"><input type="radio" class="radio" name="reply[<?php echo $id; ?>]" value="-50" <?php if($_POST['reply'][$id] == '-50') echo 'checked="checked"'; ?>/></td>
				<td class="question_radio_td"><input type="radio" class="radio" name="reply[<?php echo $id; ?>]" value="0" <?php if($_POST['reply'][$id] == '0') echo 'checked="checked"'; ?>/></td>
				<td class="question_radio_td"><input type="radio" class="radio" name="reply[<?php echo $id; ?>]" value="50" <?php if($_POST['reply'][$id] == '50') echo 'checked="checked"'; ?>/></td>
				<td class="question_radio_td"><input type="radio" class="radio" name="reply[<?php echo $id; ?>]" value="100" <?php if($_POST['reply'][$id] == '100') echo 'checked="checked"'; ?>/></td>
	
	<!-- No answer checkbox -->
				<td class="question_noansw" align="right">
<?php
				if(!isset($_POST['reply'][$id]) && isset($_POST['retake']) && !isset($_POST['noanswer'][$id]))
					echo '<input type="checkbox" class="checkbox" name="noanswer['.$id.']" />';
				elseif(isset($_POST['noanswer'][$id]))
					echo '<input type="checkbox" class="checkbox" name="noanswer['.$id.']" checked="checked"/>';
				else
					echo '&nbsp;';
?>
				</td>
				
			</tr>
			</table>
<?php
		}
		elseif($questions['questiontype'] == 'textquestion')
		{
			$number_of_rows = $questions['number_of_rows'];
	
			if($i != 0)
				echo '<br />';
?>
			<table cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="question_text"><b>Question</b></td>
				<td class="question_noansw" align="right"><b><?php if(isset($_POST['retake']) && empty($_POST['reply'][$id])) echo 'No<br/>answer'; else echo '&nbsp;';?></b></td>
			</tr>
			</table>
	
	
			<table bgcolor="<?php echo $color1; ?>" cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="question_text"><b><img src="img/zeus_question<?php echo $large; ?>.gif" style="vertical-align: middle;" alt="question" />&nbsp;<?php echo $questions['name']; ?></b></td>
				<td class="question_noansw" align="right">
<?php
				if(empty($_POST['reply'][$id]) && isset($_POST['retake']) && !isset($_POST['noanswer'][$id]))
					echo '<input type="checkbox" class="checkbox" name="noanswer['.$id.']" />';
				elseif(isset($_POST['noanswer'][$id]))
					echo '<input type="checkbox" class="checkbox" name="noanswer['.$id.']" checked="checked"/>';
				else
					echo '&nbsp;';
?>
				</td>
			</tr>
			<tr>
				<td colspan="2">
				<textarea class="question_textarea" name="reply[<?php echo $id; ?>]" cols="4" rows="<?php echo $number_of_rows; ?>" style="background-color:<?php echo $color2; ?>;"><?php if(!empty($_POST['reply'][$id])) echo get_print_value($_POST['reply'][$id]); ?></textarea>
				</td>
			</tr>
				
			</table>
<?php
		}
		elseif($questions['questiontype'] == 'multiple_choice')
		{
			if($i != 0)
				echo '<br />';
			
			$altsql = "SELECT alternative, id FROM question_alternatives WHERE question_id = $id ORDER BY sort_order";
			$altresult = my_query($altsql, $mysql_handler);

			if($questions['several'] > 0)
				$inputtype = 'checkbox';
			else
				$inputtype = 'radio';

?>
	
			<table bgcolor="<?php echo $color2; ?>" cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="question_text"><b>Question</b></td>
				<td class="question_noansw" align="right"><b><?php if(isset($_POST['retake']) && !isset($_POST['reply'][$id])) echo 'No<br/>answer'; else echo '&nbsp;';?></b></td>
			</tr>
			
			</table>
			
			<table bgcolor="<?php echo $color1; ?>" cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="question_text"><img src="img/zeus_question<?php echo $large; ?>.gif" style="vertical-align: middle;" alt="question" />&nbsp;<b><?php echo $questions['name']; ?></b></td>
				<td class="question_noansw" align="right">
<?php
				if(!isset($_POST['reply'][$id]) && isset($_POST['retake']) && !isset($_POST['noanswer'][$id]))
					echo '<input type="checkbox" class="checkbox" name="noanswer['.$id.']" />';
				elseif(isset($_POST['noanswer'][$id]))
					echo '<input type="checkbox" class="checkbox" name="noanswer['.$id.']" checked="checked"/>';
				else
					echo '&nbsp;';
?>
				</td>


			</tr>
			</table>
<?php
			for($j = 0; $alternative = mysql_fetch_assoc($altresult); $j++)
			{
				$alt_id = $alternative['id'];
				
				if($j % 2 == 0)
					$table_bgcolor = $color2;
				else
					$table_bgcolor = $color1;
	
	
?>
				<table bgcolor="<?php echo $table_bgcolor;?>" cellspacing="0" cellpadding="0" border="0">
				<tr>
					<td class="question_several">&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $alternative['alternative']; ?></td>
					
					<td class="question_radio_td"><input type="<?php echo($inputtype); ?>" class="<?php echo($inputtype); ?>" name="reply[<?php echo $id; ?>][]" value="<?php echo $alternative['alternative']; ?>" <?php if(isset($_POST['reply'][$id]) && in_array($alternative['alternative'], $_POST['reply'][$id])) echo 'checked="true"'; ?>/></td>
					
					
					<td class="question_noansw" align="right">&nbsp;</td>
				</tr>
				</table>
<?php
			}
		}
		elseif($questions['questiontype'] == 'number')
		{
			if($i != 0)
				echo '<br />';
?>
			<table cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="question_text"><b>Question</b></td>
				<td class="question_noansw" align="right"><b><?php if(isset($_POST['retake']) && !is_numeric($_POST['reply'][$id])) echo 'No<br/>answer'; else echo '&nbsp;';?></b></td>
			</tr>
			</table>
		
		
			<table bgcolor="<?php echo $color1; ?>" cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td class="question_td"><b><img src="img/zeus_question<?php echo $large; ?>.gif" style="vertical-align: middle;" alt="question" />&nbsp;<?php echo $questions['name']; ?></b></td>
				
				<td class="question_number" align="right">
				<input class="question_number_field" type="text" name="reply[<?php echo $id; ?>]" style="background-color:<?php echo $color2; ?>;" <?php if(!empty($_POST['reply'][$id])) echo 'value="' . get_print_value($_POST['reply'][$id]) . '"'; ?> /></td>
				
				<td class="question_noansw" align="right">
<?php
				if(!is_numeric($_POST['reply'][$id]) && isset($_POST['retake']) && !isset($_POST['noanswer'][$id]))
					echo '<input type="checkbox" class="checkbox" name="noanswer['.$id.']" />';
				elseif(isset($_POST['noanswer'][$id]))
					echo '<input type="checkbox" class="checkbox" name="noanswer['.$id.']" checked="checked"/>';
				else
					echo '&nbsp;';
?>
				</td>
			</tr>
			<tr>
				<td align="right" colspan="2" class="question_number_info"><?php if( !is_numeric($_POST['reply'][$id]) ) echo 'Please enter a strictly numerical value!&nbsp;&nbsp;'; else echo '&nbsp;'; ?>
				</td>
			</tr>
			</table>
<?php

		}
	
		echo "\n".'</td></tr>'."\n";
	}
?>
	
	<tr>
		<td>
		<br />
		<input type="submit" name="submit_questionnaire" class="button_green button_normal" value="Submit" />
		<input type="submit" name="cancel" class="button_red button_normal" value="Cancel" />
		<input type="hidden" name="questionnaire_id" value="<?php echo $questionnaire_id; ?>" />
		</td>
	</tr>
	
	
	</table>
</form>
<?php
}
pageFooter();
?>