<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: report_multichoice.inc.php,v 1.4 2006/06/06 13:27:10 medea7 Exp $
*/

if ($print_file)
{
	$pdf->print_h2('Answers to Multiple Choice Questions');
	$pdf->Write(5, 'Displays division of answers from all participants');
	$pdf->Ln(10);
	if($multichoice_questions_count > 0)
	{
		$header = array('Question', 'Answers');
		$width = array(130, 20);
		$align = array('L', 'R');
		unset($data);
		unset($formatting);
		if(is_array($values['alternatives']))
		{
			foreach($multichoice_questions AS $id => $values)
			{
				$questionname = $values['order'].". ". $values['name'];
				$data[] = array($questionname, "");
				$formatting[] = "B";
		
				foreach($values['alternatives'] AS $text => $percent)
				{
					$text = '   '.$text;
					$percent = number_format($percent, 1, ".", "") . " %";
					$data[] = array($text, $percent);
					$formatting[] = "";
				}
			}
		}
		$pdf->FancyTable($header,$data,$width,$align,$formatting,array($row_color1, $row_color2));
	}
	else
	{
		$pdf->Write(5, 'No Multiple Choice questions in questionnaire');
		$pdf->Ln(10);
	}
}
else
{

?>
<p>Displays division of answers from all participants</p>
<?php
	if($multichoice_questions_count > 0)
	{
		$row_color = $row_color2;	
		
		echo "<table>\n";
		echo "<tr bgcolor=\"#e0e0e0\"><td class=\"report_multi_ch\"><b>Question</b></td><td align=\"right\" class=\"report_pc\"><b>Answers</b></td></tr>\n";
			
		foreach($multichoice_questions AS $id => $values)
		{
			// Alternating row color		
			if ($row_color == $row_color2)
				$row_color = $row_color1;
			else
				$row_color = $row_color2;
				
			$questionname = $values['order'].". ". $values['name'];
			
			echo "<tr bgcolor=\"$row_color\"><td colspan=\"2\"><b>".$questionname."</b></td></tr>\n";

			if(is_array($values['alternatives']))
			{
				foreach($values['alternatives'] AS $text => $percent)
				{
					// Alternating row color		
					if ($row_color == $row_color2)
						$row_color = $row_color1;
					else
						$row_color = $row_color2;
		
					$text = '&nbsp;&nbsp;&nbsp;'.$text;
					$percent = number_format($percent, 1, ".", "") . " %";
					
					echo "<tr bgcolor=\"$row_color\"><td>$text</td><td align=\"right\">$percent</td></tr>\n";
				}
			}
		}
		echo('</table>');
	}
	else
		echo("No Multiple Choice questions in questionnaire");
}
?>