<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: report_number.inc.php,v 1.1 2006/06/06 13:28:46 medea7 Exp $
*/

if ($print_file)
{
	$pdf->print_h2('Answers to Number Questions');
	$pdf->Write(5, 'Displays histogram per number question');
	$pdf->Ln(10);
	if($number_questions_count > 0)
	{
		foreach($number_questions AS $id => $values)
		{
			$questionname = $values['order'].". ". $values['name'];
			
			$pdf->print_h4($questionname);

			$src = return_histogram_plot_link(generate_histogram_data($values['answers']),$questionname,'Value','Numbers','0');
			
			$src = str_replace(' ', '%20', $src);
			$src = str_replace('&amp;', '&', $src);
			
			// Fetch working dir
			preg_match('/(.+)\/[^\/]+$/', $_SERVER["SCRIPT_NAME"], $matches);
			$href = 'http://localhost'.$matches[1].'/'.$src;

			// Get image height
			$im = @imagecreatefrompng($href);
			$imheight = imagesy($im);

			$imheight = ($imheight/72)*25.4;
			$pdf->CheckPageBreak($imheight);

			$pdf->Image($href, $pdf->GetX(), $pdf->GetY(), 90, 0, 'PNG');
		}
	}
	else
	{
		$pdf->Write(5, 'No Number questions in questionnaire');
		$pdf->Ln(10);
	}
}
else
{

?>
<p>Displays histogram per number question</p>
<?php
	if($number_questions_count > 0)
	{
		foreach($number_questions AS $id => $values)
		{
			$questionname = $values['order'].". ". $values['name'];
			
			echo "<h4>".$questionname."</h4>\n";
			
			print_histogram_plot(generate_histogram_data($values['answers']),$questionname,'Value','Numbers','0');
		}
	}
	else
		echo("No Number questions in questionnaire");
}
?>