<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: report_summary.inc.php,v 1.4 2006/06/06 13:27:10 medea7 Exp $
*/

if ($print_file)
{
	$pdf->print_h2('Summarized valuation');
	
	if($master_question == 0 || $masterq_answers == 0)
	{
		$pdf->Write(5, 'Questionnaire contains no master question');
		$pdf->Ln(10);
	}
	else
	{
		// Piechart
		foreach($masterq AS $key => $category)
		{
			$masterq_piechart[$category['label'] . $category['explain']] = round($category['percent'], 1);
		}
		
		$src = return_piechart_link($masterq_piechart, 'Average score ('.number_format($masterq_answer_score, 1, ".", "").')');
		
		$src = str_replace(' ', '%20', $src);
		$src = str_replace('&amp;', '&', $src);

		// Fetch working dir
		preg_match('/(.+)\/[^\/]+$/', $_SERVER["SCRIPT_NAME"], $matches);

		$pdf->Image('http://localhost'.$matches[1].'/'.$src, $pdf->GetX()+80, $pdf->GetY()+10, 110, 0, 'PNG');

		$pdf->Write(5, 'Division of master question:');
		$pdf->Ln();
		$pdf->SetFont('', 'I');
		$pdf->Write(5, '"'. $master_question['name'] .'"');
		$pdf->SetFont('');
		$pdf->Ln(10);
		
		$header = array('Answer', 'Count', 'Percent');
		$width = array(40, 15, 20);
		$align = array('L', 'R', 'R');
		unset($data);
		for($i=-100;$i<=100;$i+=50)
		{
			if(!isset($masterq_answer_count[$i]))
				$masterq_answer_count[$i]=0;

			$percent = ($masterq_answer_count[$i]/$masterq_answers)*100;
			$data[] = array($i, $masterq_answer_count[$i], number_format($percent, 1, ".", "").' %');
		}
		$data[] = 1;
		
		// More data
		foreach($masterq AS $key => $category)
		{
			$data[] = array($category['label'] . $category['explain'], $category['count'], number_format($category['percent'], 1, ".", "") . ' %');
		}

		$data[] = 1;
		$data[] = array('Average score', '', number_format($masterq_answer_score, 1, ".", ""));
		$data[] = array('Median', '', number_format($masterq_answer_median, 1, ".", ""));
		$data[] = array('Standard deviation', '', number_format($masterq_answer_stddeviation, 1, ".", ""));

		$pdf->FancyTable($header,$data,$width,$align,array(),array($row_color1, $row_color2));
	}
}
else
{
	if($master_question == 0 || $masterq_answers == 0)
	{
		echo "Questionnaire contains no master question";
	}
	else
	{
?>

<p>Division of master question:<br /><i>&quot;<?php echo $master_question['name']; ?>&quot;</i></p>
<table>
	<tr><td>
		<table>
			<tr bgcolor="#e0e0e0">
				<td class="report_answer_td "><b>Answer</b></td>
				<td class="report_count_td"><b>Count</b></td>
				<td class="report_percent_td"><b>Percent</b></td>
			</tr>
<?php
			$row_color = $row_color2;
			for($i=-100;$i<=100;$i+=50)
			{
				if(!isset($masterq_answer_count[$i]))
					$masterq_answer_count[$i]=0;
				
				if ($row_color == $row_color2)
					$row_color = $row_color1;
				else
					$row_color = $row_color2;
				$percent = ($masterq_answer_count[$i]/$masterq_answers)*100;
?>
				<tr bgcolor="<?php echo($row_color); ?>">
				<td><?php echo($i); ?></td>
				<td align="right"><?php echo($masterq_answer_count[$i]); ?></td>
				<td align="right"><?php echo(number_format($percent, 1, ".", "")); ?>%</td>
				</tr>
<?php
			}
?>
			<tr bgcolor="<?php echo $row_color2; ?>">
				<td colspan="3"><hr /></td>
			</tr>
			
<?php
			$row_color = $row_color2;
			foreach($masterq AS $key => $category)
			{
				$data[] = array($category['label'], $category['count'], number_format($category['percent'], 1, ".", "") . ' %');
			
				$label = $category['label'] . $category['explain'];
				$count = $category['count'];
				$percent = number_format($category['percent'], 1, ".", "");
			
				// Alternating row color		
				if ($row_color == $row_color2)
					$row_color = $row_color1;
				else
					$row_color = $row_color2;
?>		
			
			<tr bgcolor="<?php echo ($row_color); ?>">
				<td><?php echo ($label); ?></td>
				<td align="right"><?php echo($count); ?></td>
				<td align="right"><?php echo($percent); ?>%</td>
			</tr>
<?php
			}
?>	

			<tr bgcolor="<?php echo $row_color2; ?>">
				<td colspan="3"><hr /></td>
			</tr>
			<tr bgcolor="<?php echo $row_color1; ?>">
				<td colspan="2">Average score</td>
				<td align="right"><?php echo(number_format($masterq_answer_score, 1, ".", "")); ?></td>
			</tr>
			<tr bgcolor="<?php echo $row_color2; ?>">
				<td colspan="2">Median</td>
				<td align="right"><?php echo(number_format($masterq_answer_median, 1, ".", "")); ?></td>
			</tr>
			<tr bgcolor="<?php echo $row_color1; ?>">
				<td colspan="2">Standard deviation</td>
				<td align="right"><?php echo(number_format($masterq_answer_stddeviation, 1, ".", "")); ?></td>
			</tr>
		</table>
		</td>
		
		<td>
<?php
		// Piechart
		foreach($masterq AS $key => $category)
		{
			$masterq_piechart[$category['label'] . $category['explain']] = round($category['percent'], 1);
		}
		
		print_piechart($masterq_piechart, 'Average score ('.number_format($masterq_answer_score, 1, ".", "").')');
?>
		</td>
		</tr></table>
<?php
	}
}
?>