<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: show_report.inc.php,v 1.12 2006/06/07 13:03:46 medea3 Exp $
*/

if(!is_numeric($_SESSION['active_questionnaire']) && empty($_POST['select_report']))
	print_back('');

function print_extract_inflate($section, $title, $link_args)
{
?>
	<tr>
		<td width="20" valign="middle">
<h2><?php
		if(isset($_REQUEST['hide'][$section]))
			echo('<a href="'.return_href('show_report').gen_link($section, 'S').'"><img src="img/zeus_extract.png" alt="Extract '.$title.'" /></a>');
		else
			echo('<a href="'.return_href('show_report').gen_link($section, 'H').'"><img src="img/zeus_inflate.png" alt="Inflate '.$title.'" /></a>');
?></h2>
		</td>
		<td valign="middle"><h2><?php echo($title); ?></h2></td>
	</tr>
<?php
}

// Generete link args
function gen_link($show = '', $flag = '')
{
	$link_args = '&amp;fromreport=true';
	if($flag == 'H' && $show != '') $link_args = '&amp;hide['.$show.']=true';
	if(is_array($_REQUEST['hide']))
	{
		foreach($_REQUEST['hide'] AS $key => $value)
		{
			if(!($flag == 'S' && $key == $show)) $link_args .= '&amp;hide['.$key.']=true';
		}
	}
	return $link_args;
}

// Get questionnaire ID
if( isset($_POST['select_report']) )
	$_SESSION['active_questionnaire'] = $_POST['select_report'];

$sql = "SELECT name FROM questionnaires WHERE id = ".$_SESSION['active_questionnaire'];

$result = my_query($sql, $mysql_handler);

$questionnaire_name = mysql_fetch_row($result);

include_once "inc/generate_report.inc.php";

// PDF header
if($print_file)
{
	require('inc/show_report_pdf.inc.php');
	$pdf->SetTitle('Report for questionnaire '.$questionnaire_info[0]);
	$pdf->AddPage();
	if(strlen($questionnaire_result_comment) > 0)
	{
		$pdf->Write(5, $questionnaire_result_comment);
		$pdf->Ln(10);
	}
}
else
{
	pageHeader();

	if($_SESSION['page_size'] == 'large')
		$large = "_large";
	else
		$large = "";

	if(!isset($_REQUEST['fromreport']))
	{
		if (!($multichoice_questions_count > 0))
			$_REQUEST['hide']['multichoice'] = true;
		if (!($number_questions_count > 0))
			$_REQUEST['hide']['number'] = true;
		if ($master_question == 0 || $masterq_answers == 0)
			$_REQUEST['hide']['summary'] = true;
		if (!($graded_questions_count > 0))
			$_REQUEST['hide']['answers'] = true;	
		if (!($nmb_of_categories > 0))
		{
			$_REQUEST['hide']['answers_by_category'] = true;
			$_REQUEST['hide']['category_boxplot'] = true;
		}
	}

?>
	<table width="100%">
	<tr>
		<td><h1>Report for questionnaire <i><?php echo $questionnaire_info[0]; ?></i></h1></td>
		<td align="right"><a href="<?php echo (return_href('show_report').'&amp;print_file=true'.gen_link()); ?>"><img src="img/download_as_pdf<?php echo $large; ?>.png" alt="Download as PDF" style="border: 1px solid black" /></a></td>
	</tr>
	<tr>
		<td><?php echo(nl2br($questionnaire_result_comment)); ?></td>
		<td align="right" valign="top"><form style="margin-top: 0px; margin-bottom: 0px" name="cancel" action="<?php print_href(''); ?>" method="post"><input type="submit" name="cancel" class="button_red button_nearwide" value="Back" /></form>
		</td>
	</tr>
	</table>
	<table>
<?php
}

if ( $nmb_of_questions > 0 )
{
	if($print_file)
	{
		if(!isset($_REQUEST['hide']['substantial'])) include "inc/report_substantial.inc.php";
	}
	else
	{
		print_extract_inflate('substantial', 'Substantial Facts', $link_args);
?>
		<tr>
			<td>&nbsp;</td>
			<td><?php if(!isset($_REQUEST['hide']['substantial'])) include "inc/report_substantial.inc.php"; ?></td>
		</tr>
<?php
	}
	
	if($nmb_of_answers > 0 && $nmb_of_full_answers > 0)
	{
		if($print_file)
		{
			if(!isset($_REQUEST['hide']['summary'])) include "inc/report_summary.inc.php";
		}
		else
		{
			if ($master_question != 0 || $masterq_answers != 0)
			{
				print_extract_inflate('summary', 'Summarized valuation', $link_args);
?>
				<tr>
					<td>&nbsp;</td>
					<td><?php if(!isset($_REQUEST['hide']['summary'])) include "inc/report_summary.inc.php"; ?></td>
				</tr>
<?php
			}
		}

		if($print_file)
		{
			if(!isset($_REQUEST['hide']['answers'])) include "inc/report_answers.inc.php";
		}
		else
		{
			if ($graded_questions_count > 0)
			{
				print_extract_inflate('answers', 'Answers to graded questions ( '.number_format($questionnaire_score, 1, ".", "").')', $link_args);
?>
				<tr>
					<td>&nbsp;</td>
					<td><?php if(!isset($_REQUEST['hide']['answers'])) include "inc/report_answers.inc.php"; ?></td>
				</tr>
<?php
			}	
		}
	
		if($print_file)
		{
			if(!isset($_REQUEST['hide']['category_boxplot'])) include "inc/report_category_boxplot.inc.php";
		}
		else
		{
			if ($nmb_of_categories > 0)
			{
				print_extract_inflate('category_boxplot', 'Categories', $link_args);
?>
				<tr>
					<td>&nbsp;</td>
					<td><?php if(!isset($_REQUEST['hide']['category_boxplot'])) include "inc/report_category_boxplot.inc.php"; ?></td>
				</tr>
<?php
			}
		}


		if($print_file)
		{
			if(!isset($_REQUEST['hide']['answers_by_category'])) include "inc/report_answers_by_category.inc.php";
		}
		else
		{
			if ($nmb_of_categories > 0)
			{
				print_extract_inflate('answers_by_category', 'Answers to graded questions by category', $link_args);
?>
				<tr>
					<td>&nbsp;</td>
					<td><?php if(!isset($_REQUEST['hide']['answers_by_category'])) include "inc/report_answers_by_category.inc.php"; ?></td>
				</tr>
<?php
			}
		}
		if($print_file)
		{
			if(!isset($_REQUEST['hide']['multichoice'])) include "inc/report_multichoice.inc.php";
		}
		else
		{
			if ($multichoice_questions_count > 0)
			{
				print_extract_inflate('multichoice', 'Answers to Multiple Choice Questions', $link_args);
?>
				<tr>
					<td>&nbsp;</td>
					<td><?php if(!isset($_REQUEST['hide']['multichoice'])) include "inc/report_multichoice.inc.php"; ?></td>
				</tr>
<?php
			}
		}

		if($print_file)
		{
			if(!isset($_REQUEST['hide']['number'])) include "inc/report_number.inc.php";
		}
		else
		{
			if ($number_questions_count > 0)
			{
				print_extract_inflate('number', 'Answers to Number Questions', $link_args);
?>
				<tr>
					<td>&nbsp;</td>
					<td><?php if(!isset($_REQUEST['hide']['number'])) include "inc/report_number.inc.php"; ?></td>
				</tr>
<?php
			}
		}
	}
}
else
	echo "<tr><td>There are no questions in this questionnaire!</td></tr>";

if($print_file)
{
	$filename = "report_" . $questionnaire_name . "_" . date("Ymd") . ".pdf";

	$pdf->Output($filename, 'D');
}
else
{
?>
	</table>
<?php
	pageFooter();
}
?>