<?php
/*
Copyright (c) 2006, University of Karlstad
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

$Id: create_multiboxplot.php,v 1.1 2006/06/02 08:30:09 medea8 Exp $
*/

header("Content-type: image/png");

include 'create_aligned_text.inc.php';

// Count plots
$plots = count($_REQUEST['labels']);

$labelwidth = 100;
$boxwidth = 200;
$boxheight = 15;
$boxmargin = 15;
$topmargin = 40;
$bottommargin = 35;
$leftrightmargin = 20;
$width = $boxwidth+$labelwidth+$leftrightmargin*2;
$height = ($boxheight+$boxmargin)*$plots+$topmargin+$bottommargin;
$boxspace = ($boxheight+$boxmargin);

$margin = $labelwidth+$leftrightmargin;

$im = @imagecreatetruecolor($width, $height)
    or die("Cannot Initialize new GD image stream");

// Colors
$background_color = imagecolorallocate($im, 240, 240, 240);
$line_color = imagecolorallocate($im, 0, 0, 0);
$line_color2 = imagecolorallocate($im, 100, 100, 100);
$box_color = imagecolorallocate($im, 110, 169, 227);

// Fonts
$fontfile = "./Vera.ttf";

// Styles
$dashed_line = array($line_color2, $line_color2, $line_color2, $background_color, $background_color, $background_color);

// Set background-color
imagefill($im, 0, 0, $background_color);

// Master label, only works with reasonable fontsizes
$fontsize=10;

imageTextWrapped(&$im, $width/2, $fontsize/2, $fontsize*3, $fontfile, $line_color, $_REQUEST['title'], $fontsize, $align="c");

//imagettftext($im, $fontsize, 0, $leftrightmargin+$boxwitdh-$textwidth, $fontsize*1.5, $line_color, $fontfile, $_REQUEST['title']);

// Draw lines
imagesetstyle($im, $dashed_line);
imageline($im, $margin, $topmargin, $margin, $height-25, IMG_COLOR_STYLED);
imageline($im, $margin+200, $topmargin, $margin+200, $height-25, IMG_COLOR_STYLED);
imageline($im, $margin+100, $topmargin, $margin+100, $height-25, IMG_COLOR_STYLED);
imageline($im, $margin, $height-25, $margin+200, $height-25, $line_color2);

imagettftext($im, 10, 0, $margin-14, $height-10, $line_color, $fontfile, "-100");
imagettftext($im, 10, 0, $margin+96, $height-10, $line_color, $fontfile, "0");
imagettftext($im, 10, 0, $margin+188, $height-10, $line_color, $fontfile, "100");

for($i=0;$i<$plots;$i++)
{
	$label = $_REQUEST['labels'][$i];
	$min = $_REQUEST['min'][$i];
	$max = $_REQUEST['max'][$i];
	$q1 = $_REQUEST['q1'][$i];
	$q3 = $_REQUEST['q3'][$i];
	$median = $_REQUEST['median'][$i];


	// Label, only works with reasonable fontsizes
	imageTextWrapped(&$im, $labelwidth+$leftrightmargin-10, $topmargin+$boxspace*$i+$fontsize/3, $fontsize, $fontfile, $line_color, $label, $fontsize, $align="r");
	
	// Min
	imageline($im, $margin+$min+100, $topmargin+$boxspace*$i+($boxheight*0.1), $margin+$min+100, $topmargin+$boxspace*$i+($boxheight*0.9), $line_color);
	imageline($im, $margin+$min+100, $topmargin+$boxspace*$i+($boxheight/2), $margin+$q1+100, $topmargin+$boxspace*$i+($boxheight/2), $line_color);
	
	// Q1-Q3
	imagefilledrectangle($im, $margin+$q1+100, $topmargin+$boxspace*$i, $margin+$q3+100, $topmargin+$boxspace*$i+$boxheight, $box_color);
	imagerectangle($im, $margin+$q1+100, $topmargin+$boxspace*$i, $margin+$q3+100, $topmargin+$boxspace*$i+$boxheight, $line_color);
	
	// Max
	imageline($im, $margin+$max+100, $topmargin+$boxspace*$i+($boxheight*0.1), $margin+$max+100, $topmargin+$boxspace*$i+($boxheight*0.9), $line_color);
	imageline($im, $margin+$q3+100, $topmargin+$boxspace*$i+($boxheight/2), $margin+$max+100, $topmargin+$boxspace*$i+($boxheight/2), $line_color);
	
	// Median
	imageline($im, $margin+$median+100, $topmargin+$boxspace*$i, $margin+$median+100, $topmargin+$boxspace*$i+$boxheight, $line_color);

}

imagepng($im);
imagedestroy($im);

?>